/* This file was generated by SableCC (http://www.sablecc.org/). */

package ContextExpressionLanguage.parser;

import ContextExpressionLanguage.lexer.*;
import ContextExpressionLanguage.node.*;
import ContextExpressionLanguage.analysis.*;
import java.util.*;

import java.io.DataInputStream;
import java.io.BufferedInputStream;
import java.io.IOException;

public class Parser
{
    public final Analysis ignoredTokens = new AnalysisAdapter();

    protected Node node;

    private final Lexer lexer;
    private final ListIterator stack = new LinkedList().listIterator();
    private int last_shift;
    private int last_pos;
    private int last_line;
    private Token last_token;
    private final TokenIndex converter = new TokenIndex();
    private final int[] action = new int[2];

    private final static int SHIFT = 0;
    private final static int REDUCE = 1;
    private final static int ACCEPT = 2;
    private final static int ERROR = 3;

    protected void filter() throws ParserException, LexerException, IOException
    {
    }

    public Parser(Lexer lexer)
    {
        this.lexer = lexer;

        if(actionTable == null)
        {
            try
            {
                DataInputStream s = new DataInputStream(
                    new BufferedInputStream(
                    Parser.class.getResourceAsStream("parser.dat")));

                // read actionTable
                int length = s.readInt();
                actionTable = new int[length][][];
                for(int i = 0; i < actionTable.length; i++)
                {
                    length = s.readInt();
                    actionTable[i] = new int[length][3];
                    for(int j = 0; j < actionTable[i].length; j++)
                    {
                        for(int k = 0; k < 3; k++)
                        {
                            actionTable[i][j][k] = s.readInt();
                        }
                    }
                }

                // read gotoTable
                length = s.readInt();
                gotoTable = new int[length][][];
                for(int i = 0; i < gotoTable.length; i++)
                {
                    length = s.readInt();
                    gotoTable[i] = new int[length][2];
                    for(int j = 0; j < gotoTable[i].length; j++)
                    {
                        for(int k = 0; k < 2; k++)
                        {
                            gotoTable[i][j][k] = s.readInt();
                        }
                    }
                }

                // read errorMessages
                length = s.readInt();
                errorMessages = new String[length];
                for(int i = 0; i < errorMessages.length; i++)
                {
                    length = s.readInt();
                    StringBuffer buffer = new StringBuffer();

                    for(int j = 0; j < length; j++)
                    {
                        buffer.append(s.readChar());
                    }
                    errorMessages[i] = buffer.toString();
                }

                // read errors
                length = s.readInt();
                errors = new int[length];
                for(int i = 0; i < errors.length; i++)
                {
                    errors[i] = s.readInt();
                }

                s.close();
            }
            catch(Exception e)
            {
                throw new RuntimeException("The file \"parser.dat\" is either missing or corrupted.");
            }
        }
    }

    private int goTo(int index)
    {
        int state = state();
        int low = 1;
        int high = gotoTable[index].length - 1;
        int value = gotoTable[index][0][1];

        while(low <= high)
        {
            int middle = (low + high) / 2;

            if(state < gotoTable[index][middle][0])
            {
                high = middle - 1;
            }
            else if(state > gotoTable[index][middle][0])
            {
                low = middle + 1;
            }
            else
            {
                value = gotoTable[index][middle][1];
                break;
            }
        }

        return value;
    }

    private void push(int state, Node node, boolean filter) throws ParserException, LexerException, IOException
    {
        this.node = node;

        if(filter)
        {
            filter();
        }

        if(!stack.hasNext())
        {
            stack.add(new State(state, this.node));
            return;
        }

        State s = (State) stack.next();
        s.state = state;
        s.node = this.node;
    }

    private int state()
    {
        State s = (State) stack.previous();
        stack.next();
        return s.state;
    }

    private Node pop()
    {
        return (Node) ((State) stack.previous()).node;
    }

    private int index(Switchable token)
    {
        converter.index = -1;
        token.apply(converter);
        return converter.index;
    }

    public Start parse() throws ParserException, LexerException, IOException
    {
        push(0, null, false);

        List ign = null;
        while(true)
        {
            while(index(lexer.peek()) == -1)
            {
                if(ign == null)
                {
                    ign = new TypedLinkedList(NodeCast.instance);
                }

                ign.add(lexer.next());
            }

            if(ign != null)
            {
                ignoredTokens.setIn(lexer.peek(), ign);
                ign = null;
            }

            last_pos = lexer.peek().getPos();
            last_line = lexer.peek().getLine();
            last_token = lexer.peek();

            int index = index(lexer.peek());
            action[0] = actionTable[state()][0][1];
            action[1] = actionTable[state()][0][2];

            int low = 1;
            int high = actionTable[state()].length - 1;

            while(low <= high)
            {
                int middle = (low + high) / 2;

                if(index < actionTable[state()][middle][0])
                {
                    high = middle - 1;
                }
                else if(index > actionTable[state()][middle][0])
                {
                    low = middle + 1;
                }
                else
                {
                    action[0] = actionTable[state()][middle][1];
                    action[1] = actionTable[state()][middle][2];
                    break;
                }
            }

            switch(action[0])
            {
                case SHIFT:
                    push(action[1], lexer.next(), true);
                    last_shift = action[1];
                    break;
                case REDUCE:
                    switch(action[1])
                    {
                    case 0: { Node node = new0(); push(goTo(0), node, true); } break;
                    case 1: { Node node = new1(); push(goTo(0), node, true); } break;
                    case 2: { Node node = new2(); push(goTo(1), node, true); } break;
                    case 3: { Node node = new3(); push(goTo(1), node, true); } break;
                    case 4: { Node node = new4(); push(goTo(2), node, true); } break;
                    case 5: { Node node = new5(); push(goTo(2), node, true); } break;
                    case 6: { Node node = new6(); push(goTo(3), node, true); } break;
                    case 7: { Node node = new7(); push(goTo(4), node, true); } break;
                    case 8: { Node node = new8(); push(goTo(4), node, true); } break;
                    case 9: { Node node = new9(); push(goTo(5), node, true); } break;
                    case 10: { Node node = new10(); push(goTo(5), node, true); } break;
                    case 11: { Node node = new11(); push(goTo(6), node, true); } break;
                    case 12: { Node node = new12(); push(goTo(7), node, true); } break;
                    case 13: { Node node = new13(); push(goTo(8), node, true); } break;
                    case 14: { Node node = new14(); push(goTo(8), node, true); } break;
                    case 15: { Node node = new15(); push(goTo(8), node, true); } break;
                    case 16: { Node node = new16(); push(goTo(8), node, true); } break;
                    case 17: { Node node = new17(); push(goTo(9), node, true); } break;
                    case 18: { Node node = new18(); push(goTo(9), node, true); } break;
                    case 19: { Node node = new19(); push(goTo(10), node, true); } break;
                    case 20: { Node node = new20(); push(goTo(10), node, true); } break;
                    case 21: { Node node = new21(); push(goTo(11), node, true); } break;
                    case 22: { Node node = new22(); push(goTo(11), node, true); } break;
                    case 23: { Node node = new23(); push(goTo(11), node, true); } break;
                    case 24: { Node node = new24(); push(goTo(12), node, true); } break;
                    case 25: { Node node = new25(); push(goTo(12), node, true); } break;
                    case 26: { Node node = new26(); push(goTo(12), node, true); } break;
                    case 27: { Node node = new27(); push(goTo(12), node, true); } break;
                    case 28: { Node node = new28(); push(goTo(12), node, true); } break;
                    case 29: { Node node = new29(); push(goTo(12), node, true); } break;
                    case 30: { Node node = new30(); push(goTo(13), node, true); } break;
                    case 31: { Node node = new31(); push(goTo(13), node, true); } break;
                    case 32: { Node node = new32(); push(goTo(13), node, true); } break;
                    case 33: { Node node = new33(); push(goTo(13), node, true); } break;
                    case 34: { Node node = new34(); push(goTo(14), node, true); } break;
                    case 35: { Node node = new35(); push(goTo(14), node, true); } break;
                    case 36: { Node node = new36(); push(goTo(14), node, true); } break;
                    case 37: { Node node = new37(); push(goTo(15), node, true); } break;
                    case 38: { Node node = new38(); push(goTo(15), node, true); } break;
                    case 39: { Node node = new39(); push(goTo(15), node, true); } break;
                    case 40: { Node node = new40(); push(goTo(15), node, true); } break;
                    case 41: { Node node = new41(); push(goTo(16), node, true); } break;
                    case 42: { Node node = new42(); push(goTo(16), node, true); } break;
                    case 43: { Node node = new43(); push(goTo(17), node, true); } break;
                    case 44: { Node node = new44(); push(goTo(17), node, true); } break;
                    case 45: { Node node = new45(); push(goTo(17), node, true); } break;
                    case 46: { Node node = new46(); push(goTo(17), node, true); } break;
                    case 47: { Node node = new47(); push(goTo(17), node, true); } break;
                    case 48: { Node node = new48(); push(goTo(17), node, true); } break;
                    case 49: { Node node = new49(); push(goTo(17), node, true); } break;
                    case 50: { Node node = new50(); push(goTo(17), node, true); } break;
                    case 51: { Node node = new51(); push(goTo(17), node, true); } break;
                    }
                    break;
                case ACCEPT:
                    {
                        EOF node2 = (EOF) lexer.next();
                        PExpression node1 = (PExpression) pop();
                        Start node = new Start(node1, node2);
                        return node;
                    }
                case ERROR:
                    throw new ParserException(last_token,
                        "[" + last_line + "," + last_pos + "] " +
                        errorMessages[errors[action[1]]]);
            }
        }
    }

    Node new0()
    {
        PLogicalExpression node1 = (PLogicalExpression) pop();
        ALogicalExpressionExpression node = new ALogicalExpressionExpression(node1);
        return node;
    }

    Node new1()
    {
        PExpressionApplication node1 = (PExpressionApplication) pop();
        AExpressionApplicationExpression node = new AExpressionApplicationExpression(node1);
        return node;
    }

    Node new2()
    {
        TRParenthese node4 = (TRParenthese) pop();
        PArgumentList node3 = null;
        TLParenthese node2 = (TLParenthese) pop();
        PExpressionDeclaration node1 = (PExpressionDeclaration) pop();
        AExpressionApplication node = new AExpressionApplication(node1, node2, node3, node4);
        return node;
    }

    Node new3()
    {
        TRParenthese node4 = (TRParenthese) pop();
        PArgumentList node3 = (PArgumentList) pop();
        TLParenthese node2 = (TLParenthese) pop();
        PExpressionDeclaration node1 = (PExpressionDeclaration) pop();
        AExpressionApplication node = new AExpressionApplication(node1, node2, node3, node4);
        return node;
    }

    Node new4()
    {
        PExpression node1 = (PExpression) pop();
        AExpressionArgumentList node = new AExpressionArgumentList(node1);
        return node;
    }

    Node new5()
    {
        PExpression node3 = (PExpression) pop();
        TComma node2 = (TComma) pop();
        PArgumentList node1 = (PArgumentList) pop();
        AArgumentListArgumentList node = new AArgumentListArgumentList(node1, node2, node3);
        return node;
    }

    Node new6()
    {
        PExpressionBody node2 = (PExpressionBody) pop();
        PExpressionHeader node1 = (PExpressionHeader) pop();
        AExpressionDeclaration node = new AExpressionDeclaration(node1, node2);
        return node;
    }

    Node new7()
    {
        TRParenthese node4 = (TRParenthese) pop();
        PFormalParameterList node3 = null;
        TLParenthese node2 = (TLParenthese) pop();
        TExpressionAbstraction node1 = (TExpressionAbstraction) pop();
        AExpressionHeader node = new AExpressionHeader(node1, node2, node3, node4);
        return node;
    }

    Node new8()
    {
        TRParenthese node4 = (TRParenthese) pop();
        PFormalParameterList node3 = (PFormalParameterList) pop();
        TLParenthese node2 = (TLParenthese) pop();
        TExpressionAbstraction node1 = (TExpressionAbstraction) pop();
        AExpressionHeader node = new AExpressionHeader(node1, node2, node3, node4);
        return node;
    }

    Node new9()
    {
        PFormalParameter node1 = (PFormalParameter) pop();
        AFormalParameterFormalParameterList node = new AFormalParameterFormalParameterList(node1);
        return node;
    }

    Node new10()
    {
        PFormalParameter node3 = (PFormalParameter) pop();
        TComma node2 = (TComma) pop();
        PFormalParameterList node1 = (PFormalParameterList) pop();
        AFormalParameterListFormalParameterList node = new AFormalParameterListFormalParameterList(node1, node2, node3);
        return node;
    }

    Node new11()
    {
        TIdentifier node1 = (TIdentifier) pop();
        AFormalParameter node = new AFormalParameter(node1);
        return node;
    }

    Node new12()
    {
        TRBrace node3 = (TRBrace) pop();
        PLogicalExpression node2 = (PLogicalExpression) pop();
        TLBrace node1 = (TLBrace) pop();
        AExpressionBody node = new AExpressionBody(node1, node2, node3);
        return node;
    }

    Node new13()
    {
        TRParenthese node4 = (TRParenthese) pop();
        PArgumentList node3 = null;
        TLParenthese node2 = (TLParenthese) pop();
        TIdentifier node1 = (TIdentifier) pop();
        AIdentifierFunctionApplication node = new AIdentifierFunctionApplication(node1, node2, node3, node4);
        return node;
    }

    Node new14()
    {
        TRParenthese node4 = (TRParenthese) pop();
        PArgumentList node3 = (PArgumentList) pop();
        TLParenthese node2 = (TLParenthese) pop();
        TIdentifier node1 = (TIdentifier) pop();
        AIdentifierFunctionApplication node = new AIdentifierFunctionApplication(node1, node2, node3, node4);
        return node;
    }

    Node new15()
    {
        TRParenthese node6 = (TRParenthese) pop();
        PArgumentList node5 = null;
        TLParenthese node4 = (TLParenthese) pop();
        TIdentifier node3 = (TIdentifier) pop();
        TQualifier node2 = (TQualifier) pop();
        TIdentifier node1 = (TIdentifier) pop();
        AQualifiedIdentifierFunctionApplication node = new AQualifiedIdentifierFunctionApplication(node1, node2, node3, node4, node5, node6);
        return node;
    }

    Node new16()
    {
        TRParenthese node6 = (TRParenthese) pop();
        PArgumentList node5 = (PArgumentList) pop();
        TLParenthese node4 = (TLParenthese) pop();
        TIdentifier node3 = (TIdentifier) pop();
        TQualifier node2 = (TQualifier) pop();
        TIdentifier node1 = (TIdentifier) pop();
        AQualifiedIdentifierFunctionApplication node = new AQualifiedIdentifierFunctionApplication(node1, node2, node3, node4, node5, node6);
        return node;
    }

    Node new17()
    {
        PAndExpression node1 = (PAndExpression) pop();
        AAndExpressionLogicalExpression node = new AAndExpressionLogicalExpression(node1);
        return node;
    }

    Node new18()
    {
        PAndExpression node3 = (PAndExpression) pop();
        TOr node2 = (TOr) pop();
        PLogicalExpression node1 = (PLogicalExpression) pop();
        AOrLogicalExpression node = new AOrLogicalExpression(node1, node2, node3);
        return node;
    }

    Node new19()
    {
        PEqualityExpression node1 = (PEqualityExpression) pop();
        AEqualityExpressionAndExpression node = new AEqualityExpressionAndExpression(node1);
        return node;
    }

    Node new20()
    {
        PEqualityExpression node3 = (PEqualityExpression) pop();
        TAnd node2 = (TAnd) pop();
        PAndExpression node1 = (PAndExpression) pop();
        AAndAndExpression node = new AAndAndExpression(node1, node2, node3);
        return node;
    }

    Node new21()
    {
        PRelationalExpression node1 = (PRelationalExpression) pop();
        ARelationalExpressionEqualityExpression node = new ARelationalExpressionEqualityExpression(node1);
        return node;
    }

    Node new22()
    {
        PRelationalExpression node3 = (PRelationalExpression) pop();
        TEq node2 = (TEq) pop();
        PEqualityExpression node1 = (PEqualityExpression) pop();
        AEqEqualityExpression node = new AEqEqualityExpression(node1, node2, node3);
        return node;
    }

    Node new23()
    {
        PRelationalExpression node3 = (PRelationalExpression) pop();
        TNeq node2 = (TNeq) pop();
        PEqualityExpression node1 = (PEqualityExpression) pop();
        ANeqEqualityExpression node = new ANeqEqualityExpression(node1, node2, node3);
        return node;
    }

    Node new24()
    {
        PAdditiveExpression node1 = (PAdditiveExpression) pop();
        AAdditiveExpressionRelationalExpression node = new AAdditiveExpressionRelationalExpression(node1);
        return node;
    }

    Node new25()
    {
        PSetExpression node3 = (PSetExpression) pop();
        TIn node2 = (TIn) pop();
        PAdditiveExpression node1 = (PAdditiveExpression) pop();
        AInRelationalExpression node = new AInRelationalExpression(node1, node2, node3);
        return node;
    }

    Node new26()
    {
        PAdditiveExpression node3 = (PAdditiveExpression) pop();
        TLteq node2 = (TLteq) pop();
        PAdditiveExpression node1 = (PAdditiveExpression) pop();
        ALteqRelationalExpression node = new ALteqRelationalExpression(node1, node2, node3);
        return node;
    }

    Node new27()
    {
        PAdditiveExpression node3 = (PAdditiveExpression) pop();
        TGteq node2 = (TGteq) pop();
        PAdditiveExpression node1 = (PAdditiveExpression) pop();
        AGteqRelationalExpression node = new AGteqRelationalExpression(node1, node2, node3);
        return node;
    }

    Node new28()
    {
        PAdditiveExpression node3 = (PAdditiveExpression) pop();
        TLt node2 = (TLt) pop();
        PAdditiveExpression node1 = (PAdditiveExpression) pop();
        ALtRelationalExpression node = new ALtRelationalExpression(node1, node2, node3);
        return node;
    }

    Node new29()
    {
        PAdditiveExpression node3 = (PAdditiveExpression) pop();
        TGt node2 = (TGt) pop();
        PAdditiveExpression node1 = (PAdditiveExpression) pop();
        AGtRelationalExpression node = new AGtRelationalExpression(node1, node2, node3);
        return node;
    }

    Node new30()
    {
        PAdditiveExpression node3 = (PAdditiveExpression) pop();
        TSet node2 = (TSet) pop();
        PAdditiveExpression node1 = (PAdditiveExpression) pop();
        ASetLiteralSetExpression node = new ASetLiteralSetExpression(node1, node2, node3);
        return node;
    }

    Node new31()
    {
        TIdentifier node1 = (TIdentifier) pop();
        ASetIdentifierSetExpression node = new ASetIdentifierSetExpression(node1);
        return node;
    }

    Node new32()
    {
        TIdentifier node3 = (TIdentifier) pop();
        TQualifier node2 = (TQualifier) pop();
        TIdentifier node1 = (TIdentifier) pop();
        AQualifiedSetIdentifierSetExpression node = new AQualifiedSetIdentifierSetExpression(node1, node2, node3);
        return node;
    }

    Node new33()
    {
        PFunctionApplication node1 = (PFunctionApplication) pop();
        ASetFunctionApplicationSetExpression node = new ASetFunctionApplicationSetExpression(node1);
        return node;
    }

    Node new34()
    {
        PMultiplicativeExpression node1 = (PMultiplicativeExpression) pop();
        AMultiplicativeExpressionAdditiveExpression node = new AMultiplicativeExpressionAdditiveExpression(node1);
        return node;
    }

    Node new35()
    {
        PMultiplicativeExpression node3 = (PMultiplicativeExpression) pop();
        TPlus node2 = (TPlus) pop();
        PAdditiveExpression node1 = (PAdditiveExpression) pop();
        APlusAdditiveExpression node = new APlusAdditiveExpression(node1, node2, node3);
        return node;
    }

    Node new36()
    {
        PMultiplicativeExpression node3 = (PMultiplicativeExpression) pop();
        TMinus node2 = (TMinus) pop();
        PAdditiveExpression node1 = (PAdditiveExpression) pop();
        AMinusAdditiveExpression node = new AMinusAdditiveExpression(node1, node2, node3);
        return node;
    }

    Node new37()
    {
        PUnaryExpression node1 = (PUnaryExpression) pop();
        AUnaryExpressionMultiplicativeExpression node = new AUnaryExpressionMultiplicativeExpression(node1);
        return node;
    }

    Node new38()
    {
        PUnaryExpression node3 = (PUnaryExpression) pop();
        TStar node2 = (TStar) pop();
        PMultiplicativeExpression node1 = (PMultiplicativeExpression) pop();
        AStarMultiplicativeExpression node = new AStarMultiplicativeExpression(node1, node2, node3);
        return node;
    }

    Node new39()
    {
        PUnaryExpression node3 = (PUnaryExpression) pop();
        TDiv node2 = (TDiv) pop();
        PMultiplicativeExpression node1 = (PMultiplicativeExpression) pop();
        ADivMultiplicativeExpression node = new ADivMultiplicativeExpression(node1, node2, node3);
        return node;
    }

    Node new40()
    {
        PUnaryExpression node3 = (PUnaryExpression) pop();
        TMod node2 = (TMod) pop();
        PMultiplicativeExpression node1 = (PMultiplicativeExpression) pop();
        AModMultiplicativeExpression node = new AModMultiplicativeExpression(node1, node2, node3);
        return node;
    }

    Node new41()
    {
        PValue node1 = (PValue) pop();
        AValueUnaryExpression node = new AValueUnaryExpression(node1);
        return node;
    }

    Node new42()
    {
        PUnaryExpression node2 = (PUnaryExpression) pop();
        TNot node1 = (TNot) pop();
        ANotUnaryExpression node = new ANotUnaryExpression(node1, node2);
        return node;
    }

    Node new43()
    {
        TTrue node1 = (TTrue) pop();
        ATrueValue node = new ATrueValue(node1);
        return node;
    }

    Node new44()
    {
        TFalse node1 = (TFalse) pop();
        AFalseValue node = new AFalseValue(node1);
        return node;
    }

    Node new45()
    {
        TNumber node1 = (TNumber) pop();
        ANumberValue node = new ANumberValue(node1);
        return node;
    }

    Node new46()
    {
        TText node1 = (TText) pop();
        ATextValue node = new ATextValue(node1);
        return node;
    }

    Node new47()
    {
        TIdentifier node1 = (TIdentifier) pop();
        AIdentifierValue node = new AIdentifierValue(node1);
        return node;
    }

    Node new48()
    {
        TIdentifier node3 = (TIdentifier) pop();
        TQualifier node2 = (TQualifier) pop();
        TIdentifier node1 = (TIdentifier) pop();
        AQualifiedIdentifierValue node = new AQualifiedIdentifierValue(node1, node2, node3);
        return node;
    }

    Node new49()
    {
        PFunctionApplication node1 = (PFunctionApplication) pop();
        AFunctionApplicationValue node = new AFunctionApplicationValue(node1);
        return node;
    }

    Node new50()
    {
        PExpressionDeclaration node1 = (PExpressionDeclaration) pop();
        AExpressionDeclarationValue node = new AExpressionDeclarationValue(node1);
        return node;
    }

    Node new51()
    {
        TRParenthese node3 = (TRParenthese) pop();
        PExpression node2 = (PExpression) pop();
        TLParenthese node1 = (TLParenthese) pop();
        AExpressionValue node = new AExpressionValue(node1, node2, node3);
        return node;
    }

    private static int[][][] actionTable;
/*      {
			{{-1, ERROR, 0}, {0, SHIFT, 1}, {1, SHIFT, 2}, {2, SHIFT, 3}, {6, SHIFT, 4}, {14, SHIFT, 5}, {25, SHIFT, 6}, {26, SHIFT, 7}, {27, SHIFT, 8}, },
			{{-1, REDUCE, 43}, },
			{{-1, REDUCE, 44}, },
			{{-1, ERROR, 3}, {0, SHIFT, 1}, {1, SHIFT, 2}, {2, SHIFT, 3}, {6, SHIFT, 4}, {14, SHIFT, 5}, {25, SHIFT, 6}, {26, SHIFT, 7}, {27, SHIFT, 8}, },
			{{-1, ERROR, 4}, {2, SHIFT, 23}, },
			{{-1, ERROR, 5}, {0, SHIFT, 1}, {1, SHIFT, 2}, {2, SHIFT, 3}, {6, SHIFT, 4}, {14, SHIFT, 5}, {25, SHIFT, 6}, {26, SHIFT, 7}, {27, SHIFT, 8}, },
			{{-1, REDUCE, 47}, {2, SHIFT, 26}, {23, SHIFT, 27}, },
			{{-1, REDUCE, 45}, },
			{{-1, REDUCE, 46}, },
			{{-1, ERROR, 9}, {28, ACCEPT, -1}, },
			{{-1, REDUCE, 1}, },
			{{-1, REDUCE, 50}, {2, SHIFT, 28}, },
			{{-1, ERROR, 12}, {4, SHIFT, 29}, },
			{{-1, REDUCE, 49}, },
			{{-1, REDUCE, 0}, {20, SHIFT, 31}, },
			{{-1, REDUCE, 17}, {19, SHIFT, 32}, },
			{{-1, REDUCE, 19}, {15, SHIFT, 33}, {18, SHIFT, 34}, },
			{{-1, REDUCE, 21}, },
			{{-1, REDUCE, 24}, {7, SHIFT, 35}, {8, SHIFT, 36}, {12, SHIFT, 37}, {13, SHIFT, 38}, {16, SHIFT, 39}, {17, SHIFT, 40}, {21, SHIFT, 41}, },
			{{-1, REDUCE, 34}, {9, SHIFT, 42}, {10, SHIFT, 43}, {11, SHIFT, 44}, },
			{{-1, REDUCE, 37}, },
			{{-1, REDUCE, 41}, },
			{{-1, ERROR, 22}, {3, SHIFT, 45}, },
			{{-1, ERROR, 23}, {3, SHIFT, 46}, {25, SHIFT, 47}, },
			{{-1, REDUCE, 50}, },
			{{-1, REDUCE, 42}, },
			{{-1, ERROR, 26}, {0, SHIFT, 1}, {1, SHIFT, 2}, {2, SHIFT, 3}, {3, SHIFT, 50}, {6, SHIFT, 4}, {14, SHIFT, 5}, {25, SHIFT, 6}, {26, SHIFT, 7}, {27, SHIFT, 8}, },
			{{-1, ERROR, 27}, {25, SHIFT, 53}, },
			{{-1, ERROR, 28}, {0, SHIFT, 1}, {1, SHIFT, 2}, {2, SHIFT, 3}, {3, SHIFT, 54}, {6, SHIFT, 4}, {14, SHIFT, 5}, {25, SHIFT, 6}, {26, SHIFT, 7}, {27, SHIFT, 8}, },
			{{-1, ERROR, 29}, {0, SHIFT, 1}, {1, SHIFT, 2}, {2, SHIFT, 3}, {6, SHIFT, 4}, {14, SHIFT, 5}, {25, SHIFT, 6}, {26, SHIFT, 7}, {27, SHIFT, 8}, },
			{{-1, REDUCE, 6}, },
			{{-1, ERROR, 31}, {0, SHIFT, 1}, {1, SHIFT, 2}, {2, SHIFT, 3}, {6, SHIFT, 4}, {14, SHIFT, 5}, {25, SHIFT, 6}, {26, SHIFT, 7}, {27, SHIFT, 8}, },
			{{-1, ERROR, 32}, {0, SHIFT, 1}, {1, SHIFT, 2}, {2, SHIFT, 3}, {6, SHIFT, 4}, {14, SHIFT, 5}, {25, SHIFT, 6}, {26, SHIFT, 7}, {27, SHIFT, 8}, },
			{{-1, ERROR, 33}, {0, SHIFT, 1}, {1, SHIFT, 2}, {2, SHIFT, 3}, {6, SHIFT, 4}, {14, SHIFT, 5}, {25, SHIFT, 6}, {26, SHIFT, 7}, {27, SHIFT, 8}, },
			{{-1, ERROR, 34}, {0, SHIFT, 1}, {1, SHIFT, 2}, {2, SHIFT, 3}, {6, SHIFT, 4}, {14, SHIFT, 5}, {25, SHIFT, 6}, {26, SHIFT, 7}, {27, SHIFT, 8}, },
			{{-1, ERROR, 35}, {0, SHIFT, 1}, {1, SHIFT, 2}, {2, SHIFT, 3}, {6, SHIFT, 4}, {14, SHIFT, 5}, {25, SHIFT, 6}, {26, SHIFT, 7}, {27, SHIFT, 8}, },
			{{-1, ERROR, 36}, {0, SHIFT, 1}, {1, SHIFT, 2}, {2, SHIFT, 3}, {6, SHIFT, 4}, {14, SHIFT, 5}, {25, SHIFT, 6}, {26, SHIFT, 7}, {27, SHIFT, 8}, },
			{{-1, ERROR, 37}, {0, SHIFT, 1}, {1, SHIFT, 2}, {2, SHIFT, 3}, {6, SHIFT, 4}, {14, SHIFT, 5}, {25, SHIFT, 6}, {26, SHIFT, 7}, {27, SHIFT, 8}, },
			{{-1, ERROR, 38}, {0, SHIFT, 1}, {1, SHIFT, 2}, {2, SHIFT, 3}, {6, SHIFT, 4}, {14, SHIFT, 5}, {25, SHIFT, 6}, {26, SHIFT, 7}, {27, SHIFT, 8}, },
			{{-1, ERROR, 39}, {0, SHIFT, 1}, {1, SHIFT, 2}, {2, SHIFT, 3}, {6, SHIFT, 4}, {14, SHIFT, 5}, {25, SHIFT, 6}, {26, SHIFT, 7}, {27, SHIFT, 8}, },
			{{-1, ERROR, 40}, {0, SHIFT, 1}, {1, SHIFT, 2}, {2, SHIFT, 3}, {6, SHIFT, 4}, {14, SHIFT, 5}, {25, SHIFT, 6}, {26, SHIFT, 7}, {27, SHIFT, 8}, },
			{{-1, ERROR, 41}, {0, SHIFT, 1}, {1, SHIFT, 2}, {2, SHIFT, 3}, {6, SHIFT, 4}, {14, SHIFT, 5}, {25, SHIFT, 67}, {26, SHIFT, 7}, {27, SHIFT, 8}, },
			{{-1, ERROR, 42}, {0, SHIFT, 1}, {1, SHIFT, 2}, {2, SHIFT, 3}, {6, SHIFT, 4}, {14, SHIFT, 5}, {25, SHIFT, 6}, {26, SHIFT, 7}, {27, SHIFT, 8}, },
			{{-1, ERROR, 43}, {0, SHIFT, 1}, {1, SHIFT, 2}, {2, SHIFT, 3}, {6, SHIFT, 4}, {14, SHIFT, 5}, {25, SHIFT, 6}, {26, SHIFT, 7}, {27, SHIFT, 8}, },
			{{-1, ERROR, 44}, {0, SHIFT, 1}, {1, SHIFT, 2}, {2, SHIFT, 3}, {6, SHIFT, 4}, {14, SHIFT, 5}, {25, SHIFT, 6}, {26, SHIFT, 7}, {27, SHIFT, 8}, },
			{{-1, REDUCE, 51}, },
			{{-1, REDUCE, 7}, },
			{{-1, REDUCE, 11}, },
			{{-1, ERROR, 48}, {3, SHIFT, 74}, {24, SHIFT, 75}, },
			{{-1, REDUCE, 9}, },
			{{-1, REDUCE, 13}, },
			{{-1, REDUCE, 4}, },
			{{-1, ERROR, 52}, {3, SHIFT, 76}, {24, SHIFT, 77}, },
			{{-1, REDUCE, 48}, {2, SHIFT, 78}, },
			{{-1, REDUCE, 2}, },
			{{-1, ERROR, 55}, {3, SHIFT, 79}, {24, SHIFT, 77}, },
			{{-1, ERROR, 56}, {5, SHIFT, 80}, {20, SHIFT, 31}, },
			{{-1, REDUCE, 18}, {19, SHIFT, 32}, },
			{{-1, REDUCE, 20}, {15, SHIFT, 33}, {18, SHIFT, 34}, },
			{{-1, REDUCE, 22}, },
			{{-1, REDUCE, 23}, },
			{{-1, REDUCE, 35}, {9, SHIFT, 42}, {10, SHIFT, 43}, {11, SHIFT, 44}, },
			{{-1, REDUCE, 36}, {9, SHIFT, 42}, {10, SHIFT, 43}, {11, SHIFT, 44}, },
			{{-1, REDUCE, 28}, {7, SHIFT, 35}, {8, SHIFT, 36}, },
			{{-1, REDUCE, 29}, {7, SHIFT, 35}, {8, SHIFT, 36}, },
			{{-1, REDUCE, 26}, {7, SHIFT, 35}, {8, SHIFT, 36}, },
			{{-1, REDUCE, 27}, {7, SHIFT, 35}, {8, SHIFT, 36}, },
			{{-1, REDUCE, 31}, {2, SHIFT, 26}, {7, REDUCE, 47}, {8, REDUCE, 47}, {9, REDUCE, 47}, {10, REDUCE, 47}, {11, REDUCE, 47}, {22, REDUCE, 47}, {23, SHIFT, 81}, },
			{{-1, REDUCE, 33}, {7, REDUCE, 49}, {8, REDUCE, 49}, {9, REDUCE, 49}, {10, REDUCE, 49}, {11, REDUCE, 49}, {22, REDUCE, 49}, },
			{{-1, REDUCE, 25}, },
			{{-1, ERROR, 70}, {7, SHIFT, 35}, {8, SHIFT, 36}, {22, SHIFT, 82}, },
			{{-1, REDUCE, 38}, },
			{{-1, REDUCE, 39}, },
			{{-1, REDUCE, 40}, },
			{{-1, REDUCE, 8}, },
			{{-1, ERROR, 75}, {25, SHIFT, 47}, },
			{{-1, REDUCE, 14}, },
			{{-1, ERROR, 77}, {0, SHIFT, 1}, {1, SHIFT, 2}, {2, SHIFT, 3}, {6, SHIFT, 4}, {14, SHIFT, 5}, {25, SHIFT, 6}, {26, SHIFT, 7}, {27, SHIFT, 8}, },
			{{-1, ERROR, 78}, {0, SHIFT, 1}, {1, SHIFT, 2}, {2, SHIFT, 3}, {3, SHIFT, 85}, {6, SHIFT, 4}, {14, SHIFT, 5}, {25, SHIFT, 6}, {26, SHIFT, 7}, {27, SHIFT, 8}, },
			{{-1, REDUCE, 3}, },
			{{-1, REDUCE, 12}, },
			{{-1, ERROR, 81}, {25, SHIFT, 87}, },
			{{-1, ERROR, 82}, {0, SHIFT, 1}, {1, SHIFT, 2}, {2, SHIFT, 3}, {6, SHIFT, 4}, {14, SHIFT, 5}, {25, SHIFT, 6}, {26, SHIFT, 7}, {27, SHIFT, 8}, },
			{{-1, REDUCE, 10}, },
			{{-1, REDUCE, 5}, },
			{{-1, REDUCE, 15}, },
			{{-1, ERROR, 86}, {3, SHIFT, 89}, {24, SHIFT, 77}, },
			{{-1, REDUCE, 32}, {2, SHIFT, 78}, {7, REDUCE, 48}, {8, REDUCE, 48}, {9, REDUCE, 48}, {10, REDUCE, 48}, {11, REDUCE, 48}, {22, REDUCE, 48}, },
			{{-1, REDUCE, 30}, {7, SHIFT, 35}, {8, SHIFT, 36}, },
			{{-1, REDUCE, 16}, },
        };*/
    private static int[][][] gotoTable;
/*      {
			{{-1, 51}, {0, 9}, {3, 22}, {77, 84}, },
			{{-1, 10}, },
			{{-1, 52}, {28, 55}, {78, 86}, },
			{{-1, 24}, {0, 11}, {3, 11}, {26, 11}, {28, 11}, {77, 11}, {78, 11}, },
			{{-1, 12}, },
			{{-1, 48}, },
			{{-1, 49}, {75, 83}, },
			{{-1, 30}, },
			{{-1, 13}, {41, 68}, },
			{{-1, 14}, {29, 56}, },
			{{-1, 15}, {31, 57}, },
			{{-1, 16}, {32, 58}, },
			{{-1, 17}, {33, 59}, {34, 60}, },
			{{-1, 69}, },
			{{-1, 18}, {37, 63}, {38, 64}, {39, 65}, {40, 66}, {41, 70}, {82, 88}, },
			{{-1, 19}, {35, 61}, {36, 62}, },
			{{-1, 20}, {5, 25}, {42, 71}, {43, 72}, {44, 73}, },
			{{-1, 21}, },
        };*/
    private static String[] errorMessages;
/*      {
			"expecting: 'true', 'false', '(', 'exp-abs', '!', identifier, number, text",
			"expecting: ')', '}', '+', '-', '*', '/', '%', '<', '>', '=', '<=', '>=', '!=', '&', '|', 'in', '..', ',', EOF",
			"expecting: '('",
			"expecting: '(', ')', '}', '+', '-', '*', '/', '%', '<', '>', '=', '<=', '>=', '!=', '&', '|', 'in', '..', '.', ',', EOF",
			"expecting: EOF",
			"expecting: ')', ',', EOF",
			"expecting: '(', ')', '+', '-', '*', '/', '%', '<', '>', '=', '<=', '>=', '!=', '&', '|', 'in', ',', EOF",
			"expecting: '{'",
			"expecting: ')', '|', ',', EOF",
			"expecting: ')', '}', '&', '|', ',', EOF",
			"expecting: ')', '}', '=', '!=', '&', '|', ',', EOF",
			"expecting: ')', '}', '+', '-', '<', '>', '=', '<=', '>=', '!=', '&', '|', 'in', ',', EOF",
			"expecting: ')'",
			"expecting: ')', identifier",
			"expecting: 'true', 'false', '(', ')', 'exp-abs', '!', identifier, number, text",
			"expecting: identifier",
			"expecting: '(', ')', '}', '+', '-', '*', '/', '%', '<', '>', '=', '<=', '>=', '!=', '&', '|', 'in', '..', ',', EOF",
			"expecting: ')', ','",
			"expecting: '}', '|'",
			"expecting: ')', '}', '+', '-', '=', '!=', '&', '|', ',', EOF",
			"expecting: '(', ')', '}', '+', '-', '*', '/', '%', '=', '!=', '&', '|', '..', '.', ',', EOF",
			"expecting: ')', '}', '+', '-', '*', '/', '%', '=', '!=', '&', '|', '..', ',', EOF",
			"expecting: '+', '-', '..'",
			"expecting: '(', ')', '}', '+', '-', '*', '/', '%', '=', '!=', '&', '|', '..', ',', EOF",
        };*/
    private static int[] errors;
/*      {
			0, 1, 1, 0, 2, 0, 3, 1, 1, 4, 5, 6, 7, 1, 8, 9, 10, 10, 11, 1, 1, 1, 12, 13, 1, 1, 14, 15, 14, 0, 16, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 7, 17, 17, 17, 1, 17, 17, 16, 5, 17, 18, 9, 10, 10, 10, 1, 1, 19, 19, 19, 19, 20, 21, 10, 22, 1, 1, 1, 7, 15, 1, 0, 14, 5, 16, 15, 0, 17, 17, 1, 17, 23, 19, 1, 
        };*/
}
