package contexts;

/**
 * <p>Title: MACA_CA</p>
 * <p>Description: Middleware de Autenticao e Controle de Acesso</p>
 * <p>Copyright: Copyright (c) 2000-2004</p>
 * <p>Company: Instituto do Corao - FM.USP</p>
 * @author Gustavo Motta
 * @version 3.2.1
 */

import java.util.*;
import java.text.*;

public class DateTimeContext implements Context {
  private static SimpleDateFormat   df = new SimpleDateFormat("yyyy-MM-dd'T'HH:mm:ss.SSS z", new Locale("pt", "BR"));

  public DateTimeContext() {
  }

  public Object getValue (String index) throws contexts.ContextException {
    Date now = new Date();
    if (index.equalsIgnoreCase("ano")) {
      df.applyPattern("yyyy");
      return new Integer(df.format(now));
    }
    else if (index.equalsIgnoreCase("mes")) {
      df.applyPattern("MM");
      return new Integer(df.format(now));
    }
    else if (index.equalsIgnoreCase("dia")) {
      df.applyPattern("dd");
      return new Integer(df.format(now));
    }
    else if (index.equalsIgnoreCase("hora")) {
      df.applyPattern("HH");
      return new Integer(df.format(now));
    }
    else if (index.equalsIgnoreCase("minuto")) {
      df.applyPattern("mm");
      return new Integer(df.format(now));
    }
    else if (index.equalsIgnoreCase("segundo")) {
      df.applyPattern("ss");
      return new Integer(df.format(now));
    }
    else if (index.equalsIgnoreCase("dia_semana")) {
      df.applyPattern("E");
      return df.format(now).toLowerCase();
    }
    else {
      throw new contexts.ContextException("Varivel '"+index+"' no definida no contexto 'DateTimeContext'.");
    }
  }

  public boolean inEvaluation(Object element, Object aSetName) throws contexts.ContextException {
    if (aSetName instanceof String) {
      if ("fim_de_semana".equalsIgnoreCase((String)aSetName)) {
        return (element.equals("sab") || element.equals("dom"));
      }
      else if ("dia_de_semana".equalsIgnoreCase((String)aSetName)) {
        return (element.equals("seg") || element.equals("ter") ||
                element.equals("qua") || element.equals("qui") ||
                element.equals("sex"));
      }
      else {
        throw new contexts.ContextException("Conjunto do operador 'in' '"+aSetName+"' no definido no contexto 'DateTimeContext'.");
      }
    }
    else {
      throw new contexts.ContextException("Conjunto do operador 'in' '"+aSetName+"' no definido no contexto 'DateTimeContext'.");
    }
  }

  public Object functionApplication(String functionName, Vector argumentList) throws ContextException {
    throw new ContextException("Funo '"+functionName+"' no definida no contexto 'DateTimeContext'.");
  }




}