package maca_ca;

/**
 * <p>Title: MACA_CA</p>
 * <p>Description: Middleware de Autenticao e Controle de Acesso</p>
 * <p>Copyright: Copyright (c) 2000-2004</p>
 * <p>Company: Instituto do Corao - FM.USP</p>
 * @author Gustavo Motta
 * @version 3.2.1
 */

import java.io.*;
import java.net.*;
import java.util.*;
import javax.naming.directory.*;

public class BasicPasswordFactory implements maca_ca.PasswordFactory {
  static private final char[] chars = {'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i',
                                       'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r',
                                       's', 't', 'u', 'v', 'x', 'z', '%', '=', '@',
                                       '.', ',', '$', '!', '*', '&', '#', '?', '+',
                                       '-', '/', '\\', 'S', 'T', 'U', 'V', 'X', 'Z',
                                       'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R',
                                       'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I',
                                       '0', '1', '2', '3', '4', '5', '6', '7', '8',
                                       '9'};

  public BasicPasswordFactory() {
  }

  private byte[] getNewPassword(int len) {
    byte[] pwd = new byte[len];
    Random rdm = new Random((new Date()).getTime());
    for (int i = 0; i < pwd.length; i++) {
      pwd[i] = (byte) chars[rdm.nextInt(chars.length)];
    }
    return pwd;
  }

  public void sendMail(String to_address,   // Destinataire du message
                       String from_address, // Emeteur du message
                       String sSu,          // Sujet du message
                       String sMess)        // Message
           throws IOException, ProtocolException, UnknownHostException {
    //******************************************************************************
    // -----------------------------------------------------------
    // Extracted from tMail.java
    // -----------------------------------------------------------
    // Comments : very simple eMail applet
    // -----------------------------------------------------------
    // Author : R. BERTHOU
    // E-Mail : rbl@berthou.com
    // URL    : http://www.javaside.com
    // -----------------------------------------------------------
    // 1.01 * R.BERTHOU  * 30/01/00 * add minor change
    // 1.00 * R.BERTHOU  * 01/05/98 * samples tips
    //******************************************************************************
    Socket socket;       // Le Socket
    BufferedReader in;  // Le stream de lecture du Socket
    PrintStream out;     // Le stream d'ecriture du Socket
    String host;         // Identification du poste
    String str;          // Pour la lecture de donnees

    // Identification du poste
    // host peut etre force a www.ibm.com ou autre en cas de probleme
    host = InetAddress.getLocalHost().getHostName();

    // Ouverture du socket (connection au mailServer)
    //   et des streams de lecture et d'ecriture

    socket = new Socket(System.getProperty("mail.smtp.host"), 25);
    in     = new BufferedReader(new InputStreamReader(socket.getInputStream()));
    out    = new PrintStream(socket.getOutputStream());

    // lecture du message initial
    str = in.readLine();
    if (!str.startsWith("220"))    throw new ProtocolException(str);

    while (str.indexOf('-') == 3) {
      str = in.readLine();
      if (!str.startsWith("220"))  throw new ProtocolException(str);
    }
    // fin message initial

    // Dialogue avec les Serveur de mail
    // Envoie de HELO au serveur SMTP
    out.println( "HELO " + host );
    out.flush() ;
    str = in.readLine();
    if (!str.startsWith("250"))    throw new ProtocolException(str);

    // On est connecte au serveur de Mail...

    // Envoie du Mail
    out.println( "MAIL FROM: " + from_address );
    out.flush() ;
    str = in.readLine();
    if (!str.startsWith("250"))    throw new ProtocolException(str);

    // A qui envoie t on cela
    out.println( "RCPT TO: " + to_address );
    out.flush();
    str = in.readLine();
    if (!str.startsWith("250"))    throw new ProtocolException(str);
    // Est on pret a envoyer les donnees
    out.println( "DATA" );
    out.flush();
    str = in.readLine();
    if (!str.startsWith("354"))    throw new ProtocolException(str);
    // Emmeteur - Destinataire - Sujet
    out.println("From: " + from_address);
    out.println("To: " + to_address);
    out.println("Subject: " + sSu );
    out.flush();

    out.println("Comment: Unauthenticated sender");
    out.println("X-Mailer: Simple tSmtp");
    out.println("");
    out.println( sMess );
    out.println(".");
    out.flush();

    str = in.readLine();
    if (!str.startsWith("250"))    throw new ProtocolException(str);
    out.println("QUIT");
    out.flush();
    in.close();
    socket.close();

    return;
  }

  public byte[] getNewPassword(Attributes attrs) throws PasswordErrorException {
    try {
      if (attrs != null) {
        String uid = "";
        Attribute attr = attrs.get("uid");
        if ((attr != null) && (attr.get() != null)) {
          uid = ((String) attr.get());
        }
        else {
          throw new PasswordErrorException("Atributos do usurio invlidos durante a gerao de nova senha");
        }
        attr = attrs.get("mail");
        if ((attr != null) && (attr.get() != null)) {
          String email = ((String) attr.get());
          byte[] pwd =  this.getNewPassword(6);
          sendMail(email,
                 System.getProperty("maca_ca.mail"),
                 "Cadastro no MACA",
                 "Prezado "+attrs.get("givenname").get()+", \n\n"+
                          "  O seu cadastro foi efetuado com sucesso no MACA.\n"+
                          "  O seu login  <<   "+uid+"   >> e \n"+
                          "a seu senha de acesso  <<   "+new String(pwd)+"   >>\n\n"+
                          "Grato,\n\n"+
                          "  Administrador do MACA");

          return pwd;
        }
      }
      throw new PasswordErrorException("E-mail do usurio no fornecido - impossvel gerar senha inicial");
    }
    catch (Exception exc) {
      throw new PasswordErrorException("Senha do usurio no foi criada: "+exc.getMessage());
    }
  }

}