package maca_ad;

/**
 * <p>Title: MACA_CA</p>
 * <p>Description: Middleware de Autenticao e Controle de Acesso</p>
 * <p>Copyright: Copyright (c) 2000-2004</p>
 * <p>Company: Instituto do Corao - FM.USP</p>
 * @author Gustavo Motta
 * @version 3.2.1
 */

import maca_ca.*;
import java.awt.*;
import java.util.*;
import javax.swing.*;
import javax.naming.*;
import java.awt.event.*;
import javax.swing.tree.*;
import javax.swing.event.*;
import javax.swing.border.*;
import javax.naming.directory.*;


public class AuthorizationDialog extends JDialog {

  //Variveis privadas definidas manualmente
  private Authorization _autho = null;
  private ResourceLookupComboBoxModel _resCBModel = null;
  private boolean inputChanged = false;
  private boolean _wasSaved     = false;
  private String _selResourceDN = "";
  private Vector  conflictingAuthos = new Vector();
  private ConflictingAuthorizationsTableModel conflitingTableModel = null;


  //Variveis definidas automaticamente
  Border border1;
  TitledBorder titledBorder1;
  Border border2;
  TitledBorder titledBorder2;
  Border border3;
  TitledBorder titledBorder3;
  Border border4;
  TitledBorder titledBorder4;
  Border border5;
  TitledBorder titledBorder5;
  Border border6;
  TitledBorder titledBorder6;
  Border border7;
  TitledBorder titledBorder7;
  JScrollPane authoScrollPane = new JScrollPane();
  JPanel authoPanel = new JPanel();
  JPanel jPanel2 = new JPanel();
  JComboBox privTypeComboBox = new JComboBox();
  JComboBox authoTypeComboBox = new JComboBox();
  JComboBox resComboBox = new JComboBox();
  JComboBox privComboBox = new JComboBox();
  BorderLayout borderLayout1 = new BorderLayout();
  GridBagLayout gridBagLayout1 = new GridBagLayout();
  Border border8;
  Border border9;
  JPanel southPanel = new JPanel();
  BorderLayout borderLayout2 = new BorderLayout();
  JPanel statusPanel = new JPanel();
  BorderLayout borderLayout3 = new BorderLayout();
  JPanel buttonsPanel = new JPanel();
  JButton closeButton = new JButton();
  JButton saveButton = new JButton();
  JLabel statusLabel = new JLabel();
  BorderLayout borderLayout4 = new BorderLayout();
  Border border10;
  Border border11;
  JScrollPane privExpScrollPane = new JScrollPane();
  JTextArea privExpTextArea = new JTextArea();
  JSplitPane authoSplitPane = new JSplitPane();
  Border border12;
  TitledBorder titledBorder8;
  JPanel conflictPanel = new JPanel();
  BorderLayout borderLayout5 = new BorderLayout();
  JSplitPane conflictSplitPane = new JSplitPane();
  JScrollPane leftScrollPane = new JScrollPane();
  JScrollPane rightScrollPane = new JScrollPane();
  JTree conflictTree = new JTree();
  JTable authoTable = new JTable();
  Border border13;
  TitledBorder titledBorder9;
  Border border14;
  TitledBorder titledBorder10;
  Border border15;
  TitledBorder titledBorder11;
  JButton CheckConflictsButton = new JButton();

  private boolean closeWindow() {
    if (inputChanged) {
      if (JOptionPane.showConfirmDialog(this,
                                        "Autorizao foi modificada! "+
                                        "Deseja sair SEM grav-la?", "Autorizao modificada",
                                         JOptionPane.YES_NO_OPTION,
                                         JOptionPane.QUESTION_MESSAGE) == JOptionPane.YES_OPTION) {
        try {
            this._autho.refreshAttributes();
        }
        catch (Exception exc) {
          JOptionPane.showMessageDialog(this, exc.getMessage(),
                                        "Erro lendo authorizao",
                                        JOptionPane.ERROR_MESSAGE);
        }
        return true;
      }
      else {
        return false;
      }
   }
   return true;
  }

  private void checkForConflictingAuthorizations() throws Exception {
    if (!this._autho.isNew()) {
      checkAuthorizationDialogFields();
      if (conflitingTableModel != null) {
        conflitingTableModel.clear();
      }
      conflictingAuthos = this._autho.getConflictingAuthorizations();
      MutableTreeNode rootNodes = new DefaultMutableTreeNode();
      for (int i = 0; i < conflictingAuthos.size(); i++) {
        Authorization autho = (Authorization) conflictingAuthos.get(i);
        rootNodes.insert(autho.getInheritorRoles(), rootNodes.getChildCount());
      }
      conflictTree.setModel(new DefaultTreeModel(rootNodes));
      conflictTree.setRootVisible(false);
      conflictTree.setVisible(true);
      conflictTree.setSelectionRow(0);
      this.statusLabel.setText("Status: verificaao de conflitos realizada!");
    }
  }

  private void checkAuthorizationDialogFields() throws Exception {
    String res = this._resCBModel.getSelectedResourceName();
    if ((res == null) || (res.equalsIgnoreCase(""))) {
      throw new Exception("Recurso  um campo obrigatrio!");
    }
    res = this._autho.resourceNameToLDAPresourceDN(res, true);
    this._autho.getAuthorizationAtributes().put("incorresourcedn", res);
    Group selResource = this._resCBModel.getSelectedResource();
    if (selResource != null) {
      Attribute attr = selResource.getGroupAtributes().get("incorresourcetype");
      if (attr != null) {
        this._autho.getAuthorizationAtributes().put("incorresourcetype", attr.get());
      }
    }
    String priv = (String) this.privComboBox.getSelectedItem();
    if ((priv != null) && (!priv.equalsIgnoreCase(""))) {
      this._autho.getAuthorizationAtributes().put("incorprivilege", priv);
    }
    else {
      throw new Exception("Privilgio  um campo obrigatrio!");
    }
    String privType = (String) privTypeComboBox.getSelectedItem();
    if (privType != null) {
      if ((privType.equalsIgnoreCase("+") || privType.equalsIgnoreCase("-"))) {
        this._autho.getAuthorizationAtributes().put("incorprivilegetype", privType);
      }
      else if (!this.privExpTextArea.getText().equalsIgnoreCase("")) {
        this._autho.getAuthorizationAtributes().put("incorprivilegetype", this.privExpTextArea.getText());
      }
      else {
        throw new Exception("Obrigatrio a especificao de uma regra!");
      }
    }
    else {
      throw new Exception("Tipo de privilgio  um campo obrigatrio!");
    }
    String authoType = (String) authoTypeComboBox.getSelectedItem();
    if (authoType != null) {
      if (authoType.equalsIgnoreCase("Forte")) {
        this._autho.getAuthorizationAtributes().put("incorauthorizationtype", "strong");
      }
      else if (authoType.equalsIgnoreCase("Fraca")) {
        this._autho.getAuthorizationAtributes().put("incorauthorizationtype", "weak");
      }
    }
    else {
      throw new Exception("Tipo de autorizao  um campo obrigatrio!");
    }
  }



  private AuthorizationDialog(Frame frame, String title, boolean modal) {
    super(frame, title, modal);
    try {
      jbInit();
      pack();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }

  private void resourcesComboBoxSetup() {
    resComboBox.removeAllItems();
    try {
      this._resCBModel = new ResourceLookupComboBoxModel(resComboBox, this._autho.getResource());
    }
    catch (Exception exc) {
      JOptionPane.showMessageDialog(this, exc.getMessage(),
                                    "Erro para alterar autorizao",
                                    JOptionPane.ERROR_MESSAGE);
    }
  }

  private void privilegesComboBoxSetup() throws NamingException {
    privComboBox.removeAllItems();
    Enumeration enum;
    if (this._selResourceDN.equalsIgnoreCase("")) {
      enum = this._autho.getAccessModes();
    }
    else {
      enum = this._autho.getAccessModes(this._selResourceDN);
    }
    while (enum.hasMoreElements()) {
      this.privComboBox.addItem(enum.nextElement());
    }
    this.privComboBox.getModel().setSelectedItem(this._autho.getPrivilege());
  }

  private void privilegeTypeComboBoxSetup() throws NamingException {
    this.privTypeComboBox.removeAllItems();
    this.privTypeComboBox.addItem("+");
    this.privTypeComboBox.addItem("-");
    this.privTypeComboBox.addItem("Regra");
    String privType = this._autho.getPrivilegeType();
    if (privType.equals("+") ||
        privType.equals("-")) {
      this.privTypeComboBox.getModel().setSelectedItem(privType);
      this.privExpTextArea.setEnabled(false);
    }
    else {
      this.privTypeComboBox.getModel().setSelectedItem("Regra");
      this.privExpTextArea.setEnabled(true);
      this.privExpTextArea.setText(privType);
    }
  }

  private void authorizationTypeComboBoxSetup() throws NamingException {
    this.authoTypeComboBox.removeAllItems();
    this.authoTypeComboBox.addItem("Forte");
    this.authoTypeComboBox.addItem("Fraca");
    this.authoTypeComboBox.getModel().setSelectedItem(this._autho.isStrong()?"Forte":"Fraca");
  }

  public AuthorizationDialog(Authorization aAuthorization) throws NamingException {
    this(null, "", false);
    this._autho = aAuthorization;
    if (this._autho != null) {
      this.authoScrollPane.setBorder(new TitledBorder(this.border7,"Papel - ["+this._autho.getRoleName()+"]"));
      this.resourcesComboBoxSetup();
      this.privilegesComboBoxSetup();
      this.privilegeTypeComboBoxSetup();
      this.authorizationTypeComboBoxSetup();
      this.titledBorder3.setTitle("Recurso - ["+this._autho.getResourceType()+"]");
      this.setSize(700, 650);
      Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
      this.setLocation((d.width - this.getSize().width) / 2, (d.height - this.getSize().height) / 2);
      inputChanged = false;
    }
  }

  void jbInit() throws Exception {
    border1 = BorderFactory.createEtchedBorder(Color.white,new Color(149, 142, 130));
    titledBorder1 = new TitledBorder(border1,"Autorizao");
    border2 = BorderFactory.createEtchedBorder(Color.white,new Color(159, 159, 159));
    titledBorder2 = new TitledBorder(border2,"Papel");
    border3 = BorderFactory.createEtchedBorder(Color.white,new Color(178, 178, 178));
    titledBorder3 = new TitledBorder(BorderFactory.createEtchedBorder(Color.white,new Color(178, 178, 178)),"Recurso");
    border4 = BorderFactory.createEtchedBorder(Color.white,new Color(178, 178, 178));
    titledBorder4 = new TitledBorder(border4,"Privilgio");
    border5 = BorderFactory.createEtchedBorder(Color.white,new Color(178, 178, 178));
    titledBorder5 = new TitledBorder(border5,"Tipo Privilgio");
    border6 = BorderFactory.createEtchedBorder(Color.white,new Color(178, 178, 178));
    titledBorder6 = new TitledBorder(border6,"Tipo Autorizao");
    border7 = BorderFactory.createEtchedBorder(Color.white,new Color(149, 142, 130));
    titledBorder7 = new TitledBorder(border7,"Papel");
    border8 = BorderFactory.createEtchedBorder(Color.white,new Color(149, 142, 130));
    border9 = BorderFactory.createEmptyBorder();
    border10 = BorderFactory.createEtchedBorder(Color.white,new Color(149, 142, 130));
    border11 = new TitledBorder(new EtchedBorder(EtchedBorder.RAISED,Color.white,new Color(159, 159, 159)),"Regra");
    border12 = BorderFactory.createEtchedBorder(Color.white,new Color(149, 142, 130));
    titledBorder8 = new TitledBorder(new EtchedBorder(EtchedBorder.RAISED,Color.white,new Color(149, 142, 130)),"Conflitos");
    border13 = BorderFactory.createEtchedBorder(Color.white,new Color(149, 142, 130));
    titledBorder9 = new TitledBorder(BorderFactory.createEtchedBorder(Color.white,new Color(149, 142, 130)),"Conflitos");
    border14 = new EtchedBorder(EtchedBorder.RAISED,Color.white,new Color(149, 142, 130));
    titledBorder10 = new TitledBorder(BorderFactory.createEtchedBorder(Color.white,new Color(149, 142, 130)),"Papis");
    border15 = new EtchedBorder(EtchedBorder.RAISED,Color.white,new Color(149, 142, 130));
    titledBorder11 = new TitledBorder(border15,"Autorizaes conflitantes");
    conflictSplitPane.setDividerSize(5);
    conflictSplitPane.setDividerLocation(150);
    this.setDefaultCloseOperation(WindowConstants.DO_NOTHING_ON_CLOSE);
    this.setModal(true);
    this.setTitle("Autorizao");
    this.getContentPane().setLayout(borderLayout2);
    privTypeComboBox.setBorder(titledBorder5);
    privTypeComboBox.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        privTypeComboBox_actionPerformed(e);
      }
    });
    authoTypeComboBox.setBorder(titledBorder6);
    authoTypeComboBox.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        change_actionPerformed(e);
      }
    });
    resComboBox.setBorder(titledBorder3);
    resComboBox.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        resComboBox_actionPerformed(e);
      }
    });
    privComboBox.setBorder(titledBorder4);
    privComboBox.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        change_actionPerformed(e);
      }
    });
    authoPanel.setLayout(borderLayout1);
    jPanel2.setLayout(gridBagLayout1);
    authoScrollPane.setBorder(titledBorder7);
    authoScrollPane.setPreferredSize(new Dimension(350, 350));
    jPanel2.setBorder(border9);
    southPanel.setBorder(border8);
    southPanel.setLayout(borderLayout3);
    closeButton.setMnemonic('F');
    closeButton.setText("Fechar");
    closeButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        closeButton_actionPerformed(e);
      }
    });
    saveButton.setMnemonic('G');
    saveButton.setText("Gravar");
    saveButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        saveButton_actionPerformed(e);
      }
    });
    statusLabel.setBorder(border10);
    statusLabel.setText("Status:");
    statusPanel.setLayout(borderLayout4);
    privExpTextArea.setEnabled(false);
    privExpTextArea.setBorder(border11);
    privExpTextArea.addKeyListener(new java.awt.event.KeyAdapter() {
      public void keyTyped(KeyEvent e) {
        privExpTextArea_keyTyped(e);
      }
    });
    authoSplitPane.setOrientation(JSplitPane.VERTICAL_SPLIT);
    authoSplitPane.setDividerSize(10);
    authoSplitPane.setDividerLocation(400);
    privExpScrollPane.setAlignmentX((float) 0.5);
    privExpScrollPane.setAutoscrolls(false);
    conflictPanel.setLayout(borderLayout5);
    conflictTree.setAutoscrolls(true);
    conflictTree.addTreeSelectionListener(new javax.swing.event.TreeSelectionListener() {
      public void valueChanged(TreeSelectionEvent e) {
        conflictTree_valueChanged(e);
      }
    });
    conflictPanel.setBorder(titledBorder9);
    conflictPanel.setDebugGraphicsOptions(0);
    leftScrollPane.setBorder(titledBorder10);
    leftScrollPane.setToolTipText("Papis que possuem autorizaoes conflitantes");
    rightScrollPane.setBorder(titledBorder11);
    CheckConflictsButton.setMnemonic('V');
    CheckConflictsButton.setText("Verificar conflitos");
    CheckConflictsButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        CheckConflictsButton_actionPerformed(e);
      }
    });
    this.getContentPane().add(authoSplitPane,  BorderLayout.CENTER);
    statusPanel.add(statusLabel, BorderLayout.CENTER);
    authoSplitPane.add(authoScrollPane, JSplitPane.TOP);
    authoSplitPane.setTopComponent(authoScrollPane);
    authoSplitPane.add(southPanel, JSplitPane.BOTTOM);
    authoSplitPane.setBottomComponent(southPanel);
    southPanel.add(statusPanel,  BorderLayout.SOUTH);
    authoScrollPane.getViewport().add(authoPanel, null);
    authoPanel.add(jPanel2,  BorderLayout.CENTER);
    jPanel2.add(privTypeComboBox,        new GridBagConstraints(1, 0, 1, 1, 1.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(10, 0, 30, 0), 0, 0));
    jPanel2.add(authoTypeComboBox,           new GridBagConstraints(2, 0, 1, 2, 1.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(10, 0, 30, 0), 0, 0));
    jPanel2.add(privComboBox,        new GridBagConstraints(0, 0, 1, 2, 1.0, 0.0
            ,GridBagConstraints.NORTHEAST, GridBagConstraints.HORIZONTAL, new Insets(10, 0, 31, 0), 0, 0));
    jPanel2.add(resComboBox,         new GridBagConstraints(0, 2, 3, 1, 1.0, 0.0
            ,GridBagConstraints.SOUTHEAST, GridBagConstraints.HORIZONTAL, new Insets(4, 0, 22, 0), 191, 0));
    jPanel2.add(privExpScrollPane,                  new GridBagConstraints(0, 3, 3, 1, 1.0, 1.0
            ,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(0, 0, 0, 0), 245, 0));
    privExpScrollPane.getViewport().add(privExpTextArea, null);
    southPanel.add(buttonsPanel, BorderLayout.NORTH);
    buttonsPanel.add(saveButton, null);
    buttonsPanel.add(CheckConflictsButton, null);
    buttonsPanel.add(closeButton, null);
    southPanel.add(conflictPanel, BorderLayout.CENTER);
    conflictPanel.add(conflictSplitPane, BorderLayout.CENTER);
    conflictSplitPane.add(leftScrollPane, JSplitPane.LEFT);
    conflictSplitPane.add(rightScrollPane, JSplitPane.RIGHT);
    leftScrollPane.getViewport().add(conflictTree, null);
    rightScrollPane.getViewport().add(authoTable, null);
    conflictTree.setVisible(false);
    authoTable.setVisible(false);
  }


  void closeButton_actionPerformed(ActionEvent e) {
     if (this.closeWindow()) {
       this.dispose();
     }
  }

  void saveButton_actionPerformed(ActionEvent e) {
      try {
        String res = this._resCBModel.getSelectedResourceName();
        if ((res != null) && (!res.equalsIgnoreCase(""))) {
          String applicationName = res;
          StringTokenizer strTk  = new StringTokenizer(res, ";");
          if (strTk.countTokens() >= 2) {
            applicationName = strTk.nextToken()+";"+strTk.nextToken();
          }
          if (((GlobalDefinitions.sa != null) &&
              (GlobalDefinitions.sa.AccessAllowed("GravarPrivilegios;Grupos;MACA(\""+applicationName+"\")", "Execuo")))) {
              this.checkAuthorizationDialogFields();
              this._autho.saveAuthorizationAtributes();
              this.statusLabel.setText("Status: autorizao gravada com sucesso!");
              this.inputChanged = false;
              this._wasSaved = true;
          }
          else {
            JOptionPane.showMessageDialog(this, "Voc no tem PERMISSO para\n"+
                                                 "executar esta operao!",
                                           "Advertncia",
                                           JOptionPane.WARNING_MESSAGE);
          }
        }
        else {
          throw new Exception("Recurso  um campo obrigatrio!");
        }
      }
      catch (Exception exc) {
        statusLabel.setText("Status: erro na gravao da autorizao!");
        JOptionPane.showMessageDialog(this, exc.getMessage(),
                                      "Erro gravando autorizao",
                                      JOptionPane.ERROR_MESSAGE);
      }
  }

  void change_actionPerformed(ActionEvent e) {
    this.inputChanged = true;
  }

  public boolean wasSaved() {
    return _wasSaved;
  }

  void resComboBox_actionPerformed(ActionEvent e) {
    try {
      this.inputChanged = true;
      if (this._resCBModel != null) {
        this._selResourceDN = this._autho.resourceNameToLDAPresourceDN(this._resCBModel.getSelectedResourceName(), true);
        this.privilegesComboBoxSetup();
      }
    }
    catch (Exception exc) {
      statusLabel.setText("Status: erro na gravao da autorizao!");
      JOptionPane.showMessageDialog(this, exc.getMessage(),
                                    "Erro gravando autorizao",
                                    JOptionPane.ERROR_MESSAGE);
    }
  }

  void privTypeComboBox_actionPerformed(ActionEvent e) {
    this.inputChanged = true;
    if (this.privTypeComboBox.getSelectedItem().equals("+") ||
        this.privTypeComboBox.getSelectedItem().equals("-")) {
      this.privExpTextArea.setEnabled(false);
    }
    else {
      this.privExpTextArea.setEnabled(true);
    }
  }

  void privExpTextArea_keyTyped(KeyEvent e) {
    this.inputChanged = true;
  }

  void conflictTree_valueChanged(TreeSelectionEvent e) {
    TreePath path  = conflictTree.getSelectionPath();
    if (path != null) {
      try {
        DefaultMutableTreeNode node = (DefaultMutableTreeNode) path.getLastPathComponent();
        while (node.getLevel() != 1) node = (DefaultMutableTreeNode) node.getParent();
        Role role = (Role) node.getUserObject();
        for (int i = 0; i < conflictingAuthos.size(); i++) {
          Authorization autho = (Authorization) conflictingAuthos.get(i);
          if (autho.getRoleDN().equalsIgnoreCase(role.getGroupDN())) {
            Vector authos = new Vector();
            authos.add(conflictingAuthos.get(i));
            if (conflitingTableModel == null) {
              conflitingTableModel =
                  new ConflictingAuthorizationsTableModel(authos,
                                                          this.authoTable);
              this.authoTable.setVisible(true);
            }
            else {
              conflitingTableModel.clear();
              conflitingTableModel.setAuthorizations(authos);
            }
            break;
          }
        }
      }
      catch (Exception exc) {
         JOptionPane.showMessageDialog(this, exc.getMessage(),
                                       "Erro lendo membros do grupo",
                                       JOptionPane.ERROR_MESSAGE);
      }
    }
  }

  void CheckConflictsButton_actionPerformed(ActionEvent e) {
    try {
      checkForConflictingAuthorizations();
    }
    catch (Exception exc) {
       JOptionPane.showMessageDialog(this, exc.getMessage(),
                                     "Erro verificado autorizaes conflitantes",
                                     JOptionPane.ERROR_MESSAGE);
    }
  }


}