package maca_ad;

/**
 * <p>Title: MACA_CA</p>
 * <p>Description: Middleware de Autenticao e Controle de Acesso</p>
 * <p>Copyright: Copyright (c) 2000-2004</p>
 * <p>Company: Instituto do Corao - FM.USP</p>
 * @author Gustavo Motta
 * @version 3.2.1
 */

import maca_ca.*;
import java.awt.*;
import javax.swing.*;
import javax.naming.*;
import java.awt.event.*;
import javax.swing.border.*;

public class ChangePasswordDialog extends JDialog {
  private int numTentativas = 3;

  User usr = null;
  JPanel panel1 = new JPanel();
  BorderLayout borderLayout1 = new BorderLayout();
  JPanel jPanel1 = new JPanel();
  JPanel jPanel2 = new JPanel();
  JButton okButton = new JButton();
  GridBagLayout gridBagLayout1 = new GridBagLayout();
  JLabel jLabel1 = new JLabel();
  JLabel jLabel2 = new JLabel();
  JLabel jLabel3 = new JLabel();
  JPasswordField oldPasswordField = new JPasswordField();
  JPasswordField newPasswordField = new JPasswordField();
  JPasswordField newPasswordField2 = new JPasswordField();
  Border border1;
  Border border2;
  JPanel jPanel3 = new JPanel();
  JLabel statusLabel = new JLabel();
  GridBagLayout gridBagLayout2 = new GridBagLayout();

  public ChangePasswordDialog(Frame frame, String title, boolean modal) {
    super(frame, title, modal);
    try {
      jbInit();
      pack();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }

  public ChangePasswordDialog() {
    this(null, "", false);
  }

  void jbInit() throws Exception {
    border1 = BorderFactory.createEtchedBorder(Color.white,new Color(142, 142, 142));
    border2 = BorderFactory.createEtchedBorder(Color.white,new Color(142, 142, 142));
    panel1.setLayout(borderLayout1);
    okButton.setMnemonic('C');
    okButton.setText("Confirma");
    okButton.addFocusListener(new java.awt.event.FocusAdapter() {

      public void focusGained(FocusEvent e) {
        okButton_focusGained(e);
      }

      public void focusLost(FocusEvent e) {
        okButton_focusLost(e);
      }
    });
    okButton.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        okButton_actionPerformed(e);
      }
    });
    jPanel2.setLayout(gridBagLayout1);
    jLabel1.setText("Senha atual:");
    jLabel2.setText("Nova senha:");
    jLabel3.setText("Confirmao da nova senha:");
    jPanel1.setBorder(border1);
    jPanel1.setMinimumSize(new Dimension(201, 141));
    jPanel1.setLayout(gridBagLayout2);
    jPanel2.setBorder(border2);
    this.setTitle("Alterao de senha");
    this.setModal(true);
    this.addMouseMotionListener(new java.awt.event.MouseMotionAdapter() {

      public void mouseMoved(MouseEvent e) {
        this_mouseMoved(e);
      }
    });
    this.addWindowListener(new java.awt.event.WindowAdapter() {

      public void windowOpened(WindowEvent e) {
        this_windowOpened(e);
      }
    });
    statusLabel.setText("Status:");
    oldPasswordField.addKeyListener(new java.awt.event.KeyAdapter() {

      public void keyPressed(KeyEvent e) {
        transferFocusOnEnter(e);
      }
    });
    newPasswordField.addKeyListener(new java.awt.event.KeyAdapter() {

      public void keyPressed(KeyEvent e) {
        transferFocusOnEnter(e);
      }
    });
    newPasswordField2.addKeyListener(new java.awt.event.KeyAdapter() {

      public void keyPressed(KeyEvent e) {
        transferFocusOnEnter(e);
      }
    });
    getContentPane().add(panel1);
    panel1.add(jPanel2, BorderLayout.NORTH);
    jPanel2.add(jLabel1, new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.EAST, GridBagConstraints.NONE, new Insets(0, 0, 3, 3), 0, 0));
    jPanel2.add(jLabel2, new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.EAST, GridBagConstraints.NONE, new Insets(0, 0, 3, 3), 0, 0));
    jPanel2.add(jLabel3, new GridBagConstraints(0, 2, 1, 1, 0.0, 0.0
            ,GridBagConstraints.EAST, GridBagConstraints.NONE, new Insets(0, 3, 3, 3), 0, 0));
    jPanel2.add(oldPasswordField, new GridBagConstraints(1, 0, 1, 1, 1.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 3, 3), 0, 0));
    jPanel2.add(newPasswordField, new GridBagConstraints(1, 1, 1, 1, 1.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 3, 3), 0, 0));
    jPanel2.add(newPasswordField2, new GridBagConstraints(1, 2, 1, 1, 1.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 3, 3), 0, 0));
    panel1.add(jPanel1, BorderLayout.SOUTH);
    jPanel1.add(statusLabel, new GridBagConstraints(0, 0, 1, 1, 1.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(1, 9, 1, 1), 0, 0));
    panel1.add(jPanel3, BorderLayout.CENTER);
    jPanel3.add(okButton, null);
  }

  void okButton_actionPerformed(ActionEvent e) {
    try {
      if ((GlobalDefinitions.sa != null) &&
          (GlobalDefinitions.sa.AccessAllowed("AlterarSenhaUsuario;Usuarios;MACA", "Execuo"))) {
        String newPwd  = new String(newPasswordField.getPassword());
        String newPwd2 = new String(newPasswordField2.getPassword());
        String oldPwd  = new String(oldPasswordField.getPassword());
        if (usr != null) {
          if (usr.hasPassword(oldPwd)) {
            if (newPwd.equals(newPwd2)) {
              usr.setNewPassword(oldPwd, newPwd);
              String ldapLogin = (String) GlobalDefinitions.ctx.value.getEnvironment().get(Context.SECURITY_PRINCIPAL);
              if (ldapLogin.equalsIgnoreCase(usr.getUserDN())) {
                GlobalDefinitions.ctx.value.addToEnvironment(Context.SECURITY_CREDENTIALS, newPwd);
              }
              statusLabel.setText("Status: alteraao efetuada com sucesso!");
            }
            else {
              statusLabel.setText("Status: nova senha diferente em sua confirmao!");
            }
          }
          else {
              statusLabel.setText("Status: senha atual invlida!");
              oldPasswordField.setText("");
              oldPasswordField.requestFocus();
              if ((numTentativas -= 1) < 0) {
                this.hide();
              }
          }
        }
        else {
          statusLabel.setText("Status: usurio no especificado.");
        }
      }
      else {
        statusLabel.setText("Status: usurio no autorizado para executar esta operao.");
      }
    }
    catch (Exception exc) {
       JOptionPane.showMessageDialog(this, exc.getMessage(),
                                     "Erro na alteraao de senha",
                                     JOptionPane.ERROR_MESSAGE);
    }
  }

  void transferFocusOnEnter(KeyEvent e) {
     if (e.getKeyCode() == KeyEvent.VK_ENTER) {
       e.getComponent().transferFocus();
     }
  }

  void this_windowOpened(WindowEvent e) {
    oldPasswordField.requestFocus();
  }

  void okButton_focusGained(FocusEvent e) {
    this.rootPane.setDefaultButton(okButton);
  }

  void okButton_focusLost(FocusEvent e) {
    this.rootPane.setDefaultButton(null);
  }

  void this_mouseMoved(MouseEvent e) {
    GlobalDefinitions.isUsed = true;
  }
}