package maca_ad;

/**
 * <p>Title: MACA_CA</p>
 * <p>Description: Middleware de Autenticao e Controle de Acesso</p>
 * <p>Copyright: Copyright (c) 2000-2004</p>
 * <p>Company: Instituto do Corao - FM.USP</p>
 * @author Gustavo Motta
 * @version 3.2.1
 */

import maca_ca.*;
import java.awt.*;
import java.util.*;
import java.applet.*;
import javax.swing.*;
import javax.naming.*;
import java.awt.event.*;
import javax.swing.tree.*;
import javax.swing.event.*;
import javax.swing.border.*;
import javax.naming.directory.*;
import com.borland.jbcl.layout.*;

public class GroupApplet extends JApplet {
  //Variveis de instncia definidas manualmente
  private Hashtable textFields = new Hashtable();
  private java.awt.Window container = null;
  private Group group;

  //Variveis de instncia definidas automaticamente
  boolean isStandalone = false;
  JTabbedPane groupTabbedPane = new JTabbedPane();
  JScrollPane roleScrollPane = new JScrollPane();
  JPanel rolePanel = new JPanel();
  GridBagLayout gridBagLayout1 = new GridBagLayout();
  JLabel cnLabel = new JLabel();
  JTextField cnTextField = new JTextField();
  JLabel descriptionLabel = new JLabel();
  JTextField descriptionTextField = new JTextField();
  JPanel bottomPanel = new JPanel();
  JPanel topPanel = new JPanel();
  JButton saveButton = new JButton();
  JScrollPane orgScrollPane = new JScrollPane();
  JPanel orgPanel = new JPanel();
  GridBagLayout gridBagLayout2 = new GridBagLayout();
  JLabel cnOrgLabel = new JLabel();
  JTextField cnOrgTextField = new JTextField();
  JLabel initialsOrgLabel = new JLabel();
  JTextField initialsOrgTextField = new JTextField();
  JLabel descriptionOrgLabel = new JLabel();
  JTextField descriptionOrgTextField = new JTextField();
  JLabel managerOrgLabel = new JLabel();
  JTextField managerOrgTextField = new JTextField();
  JLabel lOrgLabel = new JLabel();
  JTextField lOrgTextField = new JTextField();
  JLabel telephoneNumberOrgLabel = new JLabel();
  JTextField telephonenumberOrgTextField = new JTextField();
  Border border1;
  TitledBorder titledBorder1;
  Border border2;
  TitledBorder titledBorder2;
  Border border3;
  TitledBorder titledBorder3;
  Border border4;
  TitledBorder titledBorder4;
  Border border5;
  TitledBorder titledBorder5;
  Border border6;
  TitledBorder titledBorder6;
  Border border7;
  TitledBorder titledBorder7;
  BorderLayout borderLayout1 = new BorderLayout();
  JPanel statusPanel = new JPanel();
  Border border8;
  TitledBorder titledBorder8;
  JLabel statusLabel = new JLabel();
  BorderLayout borderLayout2 = new BorderLayout();
  JPanel buttonPanel = new JPanel();
  Border border9;
  Border border10;
  JLabel faxNumberOrgLabel = new JLabel();
  JTextField faxnumberOrgTextField = new JTextField();
  JLabel mailOrgLabel = new JLabel();
  JTextField mailOrgTextField = new JTextField();
  JLabel labeleduriOrgLabel = new JLabel();
  JTextField labeleduriOrgTextField = new JTextField();
  JButton closeGroupButton = new JButton();

  //Mtodos privados definidos manualmente
  private void textFiledsSetup() {
    textFields = new Hashtable();
    Hashtable roleHT = new Hashtable();
    textFields.put(System.getProperty("maca_ca.roleName"), roleHT);
    Hashtable orgHT = new Hashtable();
    textFields.put(System.getProperty("maca_ca.orgChartName"),orgHT);


    roleHT.put("cn",cnTextField);
    roleHT.put("description",descriptionTextField);

    orgHT.put("cn",cnOrgTextField);
    orgHT.put("initials",initialsOrgTextField);
    orgHT.put("description",descriptionOrgTextField);
    orgHT.put("manager",managerOrgTextField);
    orgHT.put("l",lOrgTextField);
    orgHT.put("telephonenumber",telephonenumberOrgTextField);
    orgHT.put("facsimiletelephonenumber",faxnumberOrgTextField);
    orgHT.put("mail",mailOrgTextField);
    orgHT.put("labeleduri",labeleduriOrgTextField);

  }

  private void clearTextFields() {
    Enumeration keysEnum = textFields.keys();
    while (keysEnum.hasMoreElements()) {
      String key = (String) keysEnum.nextElement();
      Hashtable grpTextFields = (Hashtable) textFields.get(key);
      Enumeration keysFieldsEnum = grpTextFields.keys();
      while (keysFieldsEnum.hasMoreElements()) {
        String keyField = (String) keysFieldsEnum.nextElement();
        JTextField txtFld = (JTextField) grpTextFields.get(keyField);
        txtFld.setText("");
      }
    }
  }

  private void loadFieldsFromAttributes() throws NamingException {
    Hashtable grpTextFields = (Hashtable) textFields.get(group.getGroupType());
    if (grpTextFields != null) {
      this.clearTextFields();
      Attributes grpAttrs  = group.getGroupAtributes();
      Enumeration keysEnum = grpTextFields.keys();
      while (keysEnum.hasMoreElements()) {
        String key = (String) keysEnum.nextElement();
        Attribute grpAttr = grpAttrs.get(key);
        if (grpAttr != null) {
          JTextField tf = (JTextField) grpTextFields.get(key);
          tf.setText((String) grpAttr.get());
        }
      }
    }
  }

  private void loadAttributesFromFields() throws NamingException {
    Hashtable grpTextFields = (Hashtable) textFields.get(group.getGroupType());
    if (grpTextFields != null) {
      Attributes grpAttrs  = group.getGroupAtributes();
      Enumeration keysEnum = grpTextFields.keys();
      while (keysEnum.hasMoreElements()) {
        String key = (String) keysEnum.nextElement();
        JTextField tf = (JTextField) grpTextFields.get(key);
        Attribute grpAttr = grpAttrs.get(key);
        if (grpAttr != null) {
          try {
            grpAttr.set(0, tf.getText());
          }
          catch (IllegalStateException exc) {
            // valor armazenado j est presente e os valores do atributo no so ordenados,
            // logo, o valor no  alterado
          }
        }
        else {
          grpAttrs.put(key,tf.getText());
        }
        if (group.getGroupType().equalsIgnoreCase(System.getProperty("maca_ca.orgChartName"))) {
          if (key.equalsIgnoreCase("initials")) {
            grpAttrs.put("sn",tf.getText());
          }
        }
      }
    }
  }

  public void selectTabbedPane() {
    String groupName = group.getGroupType();
    groupTabbedPane.remove(roleScrollPane);
    groupTabbedPane.remove(orgScrollPane);
    if (groupName.equalsIgnoreCase(System.getProperty("maca_ca.roleName"))) {
      groupTabbedPane.add(roleScrollPane, "");
      groupTabbedPane.setSelectedIndex(0);
    }
    else if (groupName.equalsIgnoreCase(System.getProperty("maca_ca.orgChartName"))) {
      groupTabbedPane.add(orgScrollPane, "");
      groupTabbedPane.setSelectedIndex(0);
    }
    else {
      groupTabbedPane.setSelectedIndex(-1);
    }
  }

  private void applyChangesToGroup() throws NamingException {
    loadAttributesFromFields();
    group.saveGroupAtributes();
  }

  public void setGroup(Group grp) throws NamingException {
    group = grp;
    this.loadFieldsFromAttributes();
    statusLabel.setText("Status:");
  }

  //Get a parameter value
  public String getParameter(String key, String def) {
    return isStandalone ? System.getProperty(key, def) :
      (getParameter(key) != null ? getParameter(key) : def);
  }

  //Construct the applet
  public GroupApplet(java.awt.Window frame, Group grp) throws NamingException {
    group = grp;
    container = frame;
    this.textFiledsSetup();
    this.loadFieldsFromAttributes();
  }

  public GroupApplet(java.awt.Window frame, DirContext ctx, String groupRoot, String groupRDN, boolean newGrp) throws NamingException {
    if (newGrp) {
      group = new Group(new DirContextHolder(ctx), groupRoot, groupRDN, true);
    }
    else {
      group = new Group(new DirContextHolder(ctx), groupRoot, groupRDN);
    }
    container = frame;
    this.textFiledsSetup();
    this.loadFieldsFromAttributes();
  }

  //Initialize the applet
  public void init() {
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }

  //Component initialization
  private void jbInit() throws Exception {
    this.setSize(new Dimension(400,300));
    border1 = BorderFactory.createEmptyBorder();
    titledBorder1 = new TitledBorder(new EtchedBorder(EtchedBorder.RAISED,Color.white,new Color(142, 142, 142)),"Papis do usurio");
    border2 = BorderFactory.createEtchedBorder(Color.white,new Color(142, 142, 142));
    titledBorder2 = new TitledBorder(border2,"Papis disponveis");
    border3 = new EtchedBorder(EtchedBorder.RAISED,Color.white,new Color(142, 142, 142));
    titledBorder3 = new TitledBorder(border3,"Papis disponveis");
    border4 = BorderFactory.createEmptyBorder();
    titledBorder4 = new TitledBorder(new EtchedBorder(EtchedBorder.RAISED,Color.white,new Color(142, 142, 142)),"Papis do usurio");
    border5 = new EtchedBorder(EtchedBorder.RAISED,Color.white,new Color(142, 142, 142));
    titledBorder5 = new TitledBorder(border5,"Papis do usurio");
    border6 = new EtchedBorder(EtchedBorder.RAISED,Color.white,new Color(178, 178, 178));
    titledBorder6 = new TitledBorder(border6,"Papis disponveis");
    border7 = new EtchedBorder(EtchedBorder.RAISED,Color.white,new Color(178, 178, 178));
    titledBorder7 = new TitledBorder(border7,"Papis do usurio");
    border8 = BorderFactory.createEmptyBorder();
    titledBorder8 = new TitledBorder(border8,"Status:");
    border9 = BorderFactory.createBevelBorder(BevelBorder.LOWERED,Color.white,Color.white,new Color(142, 142, 142),new Color(99, 99, 99));
    border10 = BorderFactory.createBevelBorder(BevelBorder.LOWERED,Color.white,Color.white,new Color(142, 142, 142),new Color(99, 99, 99));
    this.setSize(new Dimension(597, 404));
    this.addMouseMotionListener(new java.awt.event.MouseMotionAdapter() {

      public void mouseMoved(MouseEvent e) {
        this_mouseMoved(e);
      }
    });
    rolePanel.setLayout(gridBagLayout1);
    cnLabel.setLabelFor(cnTextField);
    cnLabel.setText("Nome:");
    descriptionLabel.setLabelFor(descriptionTextField);
    descriptionLabel.setText("Descriao:");
    saveButton.setToolTipText("Grava o grupo");
    saveButton.setMnemonic('G');
    saveButton.setText("Gravar");
    saveButton.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        saveButton_actionPerformed(e);
      }
    });
    orgPanel.setLayout(gridBagLayout2);
    cnOrgLabel.setLabelFor(cnOrgTextField);
    cnOrgLabel.setText("Nome:");
    initialsOrgLabel.setLabelFor(initialsOrgTextField);
    initialsOrgLabel.setText("Sigla:");
    descriptionOrgLabel.setLabelFor(descriptionOrgTextField);
    descriptionOrgLabel.setText("Descrio:");
    managerOrgLabel.setLabelFor(managerOrgTextField);
    managerOrgLabel.setText("Responsvel:");
    lOrgLabel.setLabelFor(lOrgTextField);
    lOrgLabel.setText("Localizao:");
    telephoneNumberOrgLabel.setLabelFor(telephonenumberOrgTextField);
    telephoneNumberOrgLabel.setText("Telefone:");
    bottomPanel.setLayout(borderLayout1);
    statusLabel.setBorder(border10);
    statusLabel.setText("Status:");
    statusPanel.setLayout(borderLayout2);
    groupTabbedPane.setTabPlacement(JTabbedPane.RIGHT);
    groupTabbedPane.addChangeListener(new javax.swing.event.ChangeListener() {

      public void stateChanged(ChangeEvent e) {
        groupTabbedPane_stateChanged(e);
      }
    });
    faxNumberOrgLabel.setText("Fax:");
    mailOrgLabel.setText("E-mail:");
    labeleduriOrgLabel.setText("URL:");
    cnTextField.setEditable(false);
    cnOrgTextField.setEditable(false);
    initialsOrgTextField.addKeyListener(new java.awt.event.KeyAdapter() {

      public void keyPressed(KeyEvent e) {
        transferFocusOnEnter(e);
      }
    });
    descriptionOrgTextField.addKeyListener(new java.awt.event.KeyAdapter() {

      public void keyPressed(KeyEvent e) {
        transferFocusOnEnter(e);
      }
    });
    managerOrgTextField.addKeyListener(new java.awt.event.KeyAdapter() {

      public void keyPressed(KeyEvent e) {
        transferFocusOnEnter(e);
      }
    });
    lOrgTextField.addKeyListener(new java.awt.event.KeyAdapter() {

      public void keyPressed(KeyEvent e) {
        transferFocusOnEnter(e);
      }
    });
    telephonenumberOrgTextField.addKeyListener(new java.awt.event.KeyAdapter() {

      public void keyPressed(KeyEvent e) {
        transferFocusOnEnter(e);
      }
    });
    mailOrgTextField.addKeyListener(new java.awt.event.KeyAdapter() {

      public void keyPressed(KeyEvent e) {
        transferFocusOnEnter(e);
      }
    });
    faxnumberOrgTextField.addKeyListener(new java.awt.event.KeyAdapter() {

      public void keyPressed(KeyEvent e) {
        transferFocusOnEnter(e);
      }
    });
    labeleduriOrgTextField.addKeyListener(new java.awt.event.KeyAdapter() {

      public void keyPressed(KeyEvent e) {
        labeleduriOrgTextField_keyPressed(e);
      }
    });
    closeGroupButton.setToolTipText("Fechar a janela");
    closeGroupButton.setMnemonic('F');
    closeGroupButton.setText("Fechar");
    closeGroupButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        closeGroupButton_actionPerformed(e);
      }
    });
    this.getContentPane().add(topPanel, BorderLayout.NORTH);
    this.getContentPane().add(groupTabbedPane, BorderLayout.CENTER);
    groupTabbedPane.add(roleScrollPane, "Papis");
    groupTabbedPane.add(orgScrollPane, System.getProperty("maca_ca.orgChartName"));
    this.getContentPane().add(bottomPanel, BorderLayout.SOUTH);
    bottomPanel.add(statusPanel, BorderLayout.CENTER);
    statusPanel.add(statusLabel, BorderLayout.SOUTH);
    statusPanel.add(buttonPanel, BorderLayout.NORTH);
    buttonPanel.add(saveButton, null);
    buttonPanel.add(closeGroupButton, null);
    orgScrollPane.getViewport().add(orgPanel, null);
    orgPanel.add(cnOrgLabel, new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.EAST, GridBagConstraints.NONE, new Insets(0, 2, 2, 2), 0, 0));
    orgPanel.add(cnOrgTextField, new GridBagConstraints(1, 0, 1, 1, 1.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(0, 2, 2, 0), 0, 0));
    orgPanel.add(initialsOrgLabel, new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.EAST, GridBagConstraints.NONE, new Insets(0, 2, 2, 2), 0, 0));
    orgPanel.add(initialsOrgTextField, new GridBagConstraints(1, 1, 1, 1, 1.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(0, 2, 2, 0), 0, 0));
    orgPanel.add(descriptionOrgLabel, new GridBagConstraints(0, 2, 1, 1, 0.0, 0.0
            ,GridBagConstraints.EAST, GridBagConstraints.NONE, new Insets(0, 2, 2, 2), 0, 0));
    orgPanel.add(descriptionOrgTextField, new GridBagConstraints(1, 2, 1, 1, 1.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(0, 2, 2, 0), 0, 0));
    orgPanel.add(managerOrgLabel, new GridBagConstraints(0, 3, 1, 1, 0.0, 0.0
            ,GridBagConstraints.EAST, GridBagConstraints.NONE, new Insets(0, 2, 2, 2), 0, 0));
    orgPanel.add(managerOrgTextField, new GridBagConstraints(1, 3, 1, 1, 1.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(0, 2, 2, 0), 0, 0));
    orgPanel.add(lOrgLabel, new GridBagConstraints(0, 4, 1, 1, 0.0, 0.0
            ,GridBagConstraints.EAST, GridBagConstraints.NONE, new Insets(0, 2, 2, 2), 0, 0));
    orgPanel.add(lOrgTextField, new GridBagConstraints(1, 4, 1, 1, 1.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(0, 2, 2, 0), 0, 0));
    orgPanel.add(telephoneNumberOrgLabel, new GridBagConstraints(0, 5, 1, 1, 0.0, 0.0
            ,GridBagConstraints.EAST, GridBagConstraints.NONE, new Insets(0, 2, 2, 2), 0, 0));
    orgPanel.add(telephonenumberOrgTextField, new GridBagConstraints(1, 5, 1, 1, 1.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(0, 2, 2, 0), 0, 0));
    orgPanel.add(faxNumberOrgLabel, new GridBagConstraints(0, 6, 1, 1, 0.0, 0.0
            ,GridBagConstraints.EAST, GridBagConstraints.NONE, new Insets(0, 2, 2, 2), 0, 0));
    orgPanel.add(faxnumberOrgTextField, new GridBagConstraints(1, 6, 1, 1, 1.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(0, 2, 2, 0), 0, 0));
    orgPanel.add(mailOrgLabel, new GridBagConstraints(0, 7, 1, 1, 0.0, 0.0
            ,GridBagConstraints.EAST, GridBagConstraints.NONE, new Insets(0, 2, 2, 2), 0, 0));
    orgPanel.add(mailOrgTextField, new GridBagConstraints(1, 7, 1, 1, 1.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(0, 2, 2, 0), 0, 0));
    orgPanel.add(labeleduriOrgLabel, new GridBagConstraints(0, 8, 1, 1, 0.0, 0.0
            ,GridBagConstraints.EAST, GridBagConstraints.NONE, new Insets(0, 2, 2, 2), 0, 0));
    orgPanel.add(labeleduriOrgTextField, new GridBagConstraints(1, 8, 1, 1, 1.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(0, 2, 2, 0), 0, 0));
    roleScrollPane.getViewport().add(rolePanel, null);
    rolePanel.add(cnLabel, new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.EAST, GridBagConstraints.NONE, new Insets(0, 2, 2, 2), 0, 0));
    rolePanel.add(cnTextField, new GridBagConstraints(1, 0, 1, 1, 1.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 2, 2), 0, 0));
    rolePanel.add(descriptionLabel, new GridBagConstraints(0, 2, 1, 1, 0.0, 0.0
            ,GridBagConstraints.EAST, GridBagConstraints.NONE, new Insets(0, 2, 2, 2), 0, 0));
    rolePanel.add(descriptionTextField, new GridBagConstraints(1, 2, 1, 1, 1.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 2, 2), 0, 0));
    groupTabbedPane.setSelectedIndex(0);
  }

  //Start the applet
  public void start() {
    selectTabbedPane();
    if (this.group.isNew()) {
      this.closeGroupButton.setVisible(true);
    }
    else {
      this.closeGroupButton.setVisible(false);
    }
 }

  //Stop the applet
  public void stop() {
  }

  //Destroy the applet
  public void destroy() {
  }

  //Get Applet information
  public String getAppletInfo() {
    return "Applet Information";
  }

  //Get parameter info
  public String[][] getParameterInfo() {
    return null;
  }

  void saveButton_actionPerformed(ActionEvent e) {
    try {
      if ((GlobalDefinitions.sa != null) &&
          (GlobalDefinitions.sa.AccessAllowed("GravarGrupo;Grupos;MACA", "Execuo"))) {
        this.applyChangesToGroup();
        statusLabel.setText("Status: grupo gravado com sucesso!");
      }
      else {
        JOptionPane.showMessageDialog(this, "Voc no tem PERMISSO para\n"+
                                            "executar esta operao!",
                                      "Advertncia",
                                      JOptionPane.WARNING_MESSAGE);
      }
    }
    catch (NamingException exc) {
      statusLabel.setText("Status: erro na gravao do grupo! - "+exc.getMessage());
    }
  }

  void groupTabbedPane_stateChanged(ChangeEvent e) {
    statusLabel.setText("Status:");
  }

  void transferFocusOnEnter(KeyEvent e) {
     if (e.getKeyCode() == KeyEvent.VK_ENTER) {
       e.getComponent().transferFocus();
     }
  }

  void labeleduriOrgTextField_keyPressed(KeyEvent e) {
   if (e.getKeyCode() == KeyEvent.VK_ENTER) {
    initialsOrgTextField.requestFocus();
   }
  }

  void this_mouseMoved(MouseEvent e) {
    GlobalDefinitions.isUsed = true;
  }

  void closeGroupButton_actionPerformed(ActionEvent e) {
    if (container != null) {
      container.dispatchEvent(new WindowEvent(container, WindowEvent.WINDOW_CLOSING));
    }
  }

}