package maca_ad;

/**
 * <p>Title: MACA_CA</p>
 * <p>Description: Middleware de Autenticao e Controle de Acesso</p>
 * <p>Copyright: Copyright (c) 2000-2004</p>
 * <p>Company: Instituto do Corao - FM.USP</p>
 * @author Gustavo Motta
 * @version 3.2.1
 */

import java.awt.*;
import javax.swing.*;
import javax.swing.border.*;
import java.awt.event.*;

public class NewGroupDialog extends JDialog {
  boolean okButtonPressed = false;
  JPanel panel1 = new JPanel();
  BorderLayout borderLayout1 = new BorderLayout();
  JPanel UIDPanel = new JPanel();
  JPanel centerPanel = new JPanel();
  JButton okButton = new JButton();
  JButton cancelButton = new JButton();
  Border border1;
  Border border2;
  TitledBorder titledBorder1;
  JTextField uidTextField = new JTextField();
  GridBagLayout gridBagLayout1 = new GridBagLayout();
  JPanel bottomPanel = new JPanel();
  JLabel statusLabel = new JLabel();
  BorderLayout borderLayout2 = new BorderLayout();
  Border border3;
  Border border4;

  public NewGroupDialog(Frame frame, String title, boolean modal) {
    super(frame, title, modal);
    try {
      jbInit();
      pack();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }

  public NewGroupDialog() {
    this(null, "", false);
  }

  void jbInit() throws Exception {
    border1 = BorderFactory.createEtchedBorder(Color.white,new Color(142, 142, 142));
    border2 = BorderFactory.createEtchedBorder(Color.white,new Color(142, 142, 142));
    titledBorder1 = new TitledBorder(BorderFactory.createEtchedBorder(Color.white,new Color(142, 142, 142)),"Entre com NOME do novo grupo");
    border3 = BorderFactory.createEtchedBorder(Color.white,new Color(142, 142, 142));
    border4 = BorderFactory.createCompoundBorder(BorderFactory.createEtchedBorder(Color.white,new Color(142, 142, 142)),BorderFactory.createEmptyBorder(2,2,2,2));
    panel1.setLayout(borderLayout1);
    okButton.setMnemonic('C');
    okButton.setText("Confirma");
    this.rootPane.setDefaultButton(okButton);
    okButton.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        okButton_actionPerformed(e);
      }
    });
    cancelButton.setText("Fecha");
    cancelButton.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        cancelButton_actionPerformed(e);
      }
    });
    centerPanel.setBorder(border1);
    UIDPanel.setBorder(titledBorder1);
    UIDPanel.setLayout(gridBagLayout1);
    this.setTitle("Novo Grupo");
    this.setModal(true);
    this.setResizable(false);
    this.addMouseMotionListener(new java.awt.event.MouseMotionAdapter() {

      public void mouseMoved(MouseEvent e) {
        this_mouseMoved(e);
      }
    });
    statusLabel.setText("Status:");
    bottomPanel.setLayout(borderLayout2);
    bottomPanel.setBorder(border4);
    uidTextField.addKeyListener(new java.awt.event.KeyAdapter() {

      public void keyPressed(KeyEvent e) {
        uidTextField_keyPressed(e);
      }
    });
    getContentPane().add(panel1);
    panel1.add(UIDPanel, BorderLayout.NORTH);
    UIDPanel.add(uidTextField, new GridBagConstraints(0, 0, 1, 1, 1.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(5, 5, 5, 5), 0, 0));
    panel1.add(centerPanel, BorderLayout.CENTER);
    centerPanel.add(okButton, null);
    centerPanel.add(cancelButton, null);
    this.getContentPane().add(bottomPanel, BorderLayout.SOUTH);
    bottomPanel.add(statusLabel, BorderLayout.CENTER);
  }

  void cancelButton_actionPerformed(ActionEvent e) {
    okButtonPressed = false;
    this.hide();
  }

  void okButton_actionPerformed(ActionEvent e) {
    if (uidTextField.getText().equalsIgnoreCase("")) {
      okButtonPressed = false;
      statusLabel.setText("Status: NOME do grupo no pode ser vazio!");
      uidTextField.requestFocus();
    }
    else if (uidTextField.getText().equalsIgnoreCase(System.getProperty("maca_ca.orgChartName")) ||
             uidTextField.getText().equalsIgnoreCase(System.getProperty("maca_ca.roleName"))) {
      okButtonPressed = false;
      statusLabel.setText("Status: NOME do grupo no pode ser "+uidTextField.getText()+"!");
      uidTextField.requestFocus();
    }
    else {
      okButtonPressed = true;
      this.hide();
    }
  }


  void uidTextField_keyPressed(KeyEvent e) {
     if (e.getKeyCode() == KeyEvent.VK_ENTER) {
        e.getComponent().transferFocus();
     }
  }

  void this_mouseMoved(MouseEvent e) {
    GlobalDefinitions.isUsed = true;
  }

}