package maca_ad;

/**
 * <p>Title: MACA_CA</p>
 * <p>Description: Middleware de Autenticao e Controle de Acesso</p>
 * <p>Copyright: Copyright (c) 2000-2004</p>
 * <p>Company: Instituto do Corao - FM.USP</p>
 * @author Gustavo Motta
 * @version 3.2.1
 */

import java.awt.*;
import java.util.*;
import javax.swing.*;
import java.awt.event.*;
import javax.swing.border.*;

public class NewUIDDialog extends JDialog {
  //variveis privadas

  //variveis pblicas
  boolean okButtonPressed = false;
  JPanel panel1 = new JPanel();
  BorderLayout borderLayout1 = new BorderLayout();
  JPanel UIDPanel = new JPanel();
  JPanel centerPanel = new JPanel();
  JButton okButton = new JButton();
  JButton cancelButton = new JButton();
  Border border1;
  Border border2;
  TitledBorder titledBorder1;
  GridBagLayout gridBagLayout1 = new GridBagLayout();
  JPanel bottomPanel = new JPanel();
  JLabel statusLabel = new JLabel();
  BorderLayout borderLayout2 = new BorderLayout();
  Border border3;
  Border border4;
  JTextField employeeNumberTextField = new JTextField();
  JTextField givenNameTextField = new JTextField();
  JTextField uidTextField = new JTextField();
  String     areaMeio = "";
  String     cargo    = "";
  JLabel employeeNumberLabel = new JLabel();
  JLabel givenNameLabel = new JLabel();
  JLabel uidLabel = new JLabel();

  private String formatNamesToLowerCase(String aName) {
    StringTokenizer strToken = new StringTokenizer(aName);
    String nome = "";
    while (strToken.hasMoreTokens()) {
      String token = strToken.nextToken();
      if (!token.equalsIgnoreCase("da") &&
          !token.equalsIgnoreCase("de") &&
          !token.equalsIgnoreCase("di") &&
          !token.equalsIgnoreCase("do") &&
          !token.equalsIgnoreCase("du") &&
          !token.equalsIgnoreCase("das") &&
          !token.equalsIgnoreCase("dos")) {
        if (token.length() > 1) {
          token = token.substring(0,1) + token.substring(1, token.length()).toLowerCase();
        }
      }
      else {
        token = token.toLowerCase();
      }
      nome = nome + (nome.equalsIgnoreCase("") ? "" : " ") + token;
    }
    return nome;
  }


  public NewUIDDialog(Frame frame, String title, boolean modal) {
    super(frame, title, modal);
    try {
      jbInit();
      pack();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }

  public NewUIDDialog() {
    this(null, "", false);
  }

  void jbInit() throws Exception {
    border1 = BorderFactory.createEtchedBorder(Color.white,new Color(142, 142, 142));
    border2 = BorderFactory.createEtchedBorder(Color.white,new Color(142, 142, 142));
    titledBorder1 = new TitledBorder(BorderFactory.createEtchedBorder(Color.white,new Color(142, 142, 142)),"");
    border3 = BorderFactory.createEtchedBorder(Color.white,new Color(142, 142, 142));
    border4 = BorderFactory.createCompoundBorder(BorderFactory.createEtchedBorder(Color.white,new Color(142, 142, 142)),BorderFactory.createEmptyBorder(2,2,2,2));
    panel1.setLayout(borderLayout1);
    okButton.setMnemonic('C');
    okButton.setText("Confirma");
    okButton.addFocusListener(new java.awt.event.FocusAdapter() {

      public void focusGained(FocusEvent e) {
        okButton_focusGained(e);
      }

      public void focusLost(FocusEvent e) {
        okButton_focusLost(e);
      }
    });
    okButton.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        okButton_actionPerformed(e);
      }
    });
    cancelButton.setText("Fecha");
    cancelButton.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        cancelButton_actionPerformed(e);
      }
    });
    centerPanel.setBorder(border1);
    centerPanel.setMaximumSize(new Dimension(400, 30));
    centerPanel.setMinimumSize(new Dimension(100, 30));
    centerPanel.setPreferredSize(new Dimension(350, 40));
    UIDPanel.setBorder(titledBorder1);
    UIDPanel.setMaximumSize(new Dimension(400, 160));
    UIDPanel.setPreferredSize(new Dimension(350, 130));
    UIDPanel.setLayout(gridBagLayout1);
    this.setTitle("LOGIN do Novo Usurio");
    this.setModal(true);
    this.addMouseMotionListener(new java.awt.event.MouseMotionAdapter() {

      public void mouseMoved(MouseEvent e) {
        this_mouseMoved(e);
      }
    });
    this.addWindowListener(new java.awt.event.WindowAdapter() {

      public void windowOpened(WindowEvent e) {
        this_windowOpened(e);
      }

      public void windowClosed(WindowEvent e) {
        this_windowClosed(e);
      }
    });
    this.addMouseMotionListener(new java.awt.event.MouseMotionAdapter() {

      public void mouseMoved(MouseEvent e) {
        this_mouseMoved(e);
      }
    });
    statusLabel.setText("Status:");
    bottomPanel.setLayout(borderLayout2);
    bottomPanel.setBorder(border4);
    bottomPanel.setMaximumSize(new Dimension(400, 160));
    bottomPanel.setMinimumSize(new Dimension(100, 20));
    bottomPanel.setPreferredSize(new Dimension(350, 20));
    givenNameTextField.addKeyListener(new java.awt.event.KeyAdapter() {

      public void keyPressed(KeyEvent e) {
        givenName_keyPressed(e);
      }
    });
    employeeNumberLabel.setHorizontalAlignment(SwingConstants.RIGHT);
    employeeNumberLabel.setText("Matrcula:");
    givenNameLabel.setHorizontalAlignment(SwingConstants.RIGHT);
    givenNameLabel.setText("Nome:");
    uidLabel.setText("Login:");
    uidTextField.addKeyListener(new java.awt.event.KeyAdapter() {

      public void keyPressed(KeyEvent e) {
        textField_keyPressed(e);
      }
    });
    employeeNumberTextField.addKeyListener(new java.awt.event.KeyAdapter() {

      public void keyPressed(KeyEvent e) {
        employeeNumberTextField_keyPressed(e);
      }
    });
    employeeNumberTextField.setToolTipText("Pressione F1 para localizar funcionrio pelo nome");
    panel1.setMaximumSize(new Dimension(400, 190));
    panel1.setMinimumSize(new Dimension(100, 70));
    panel1.setPreferredSize(new Dimension(350, 190));
    getContentPane().add(panel1);
    panel1.add(UIDPanel, BorderLayout.NORTH);
    UIDPanel.add(employeeNumberTextField, new GridBagConstraints(2, 0, 1, 1, 1.0, 0.0
            ,GridBagConstraints.EAST, GridBagConstraints.HORIZONTAL, new Insets(5, 0, 5, 5), 0, 0));
    UIDPanel.add(givenNameTextField, new GridBagConstraints(1, 1, 2, 1, 1.0, 0.0
            ,GridBagConstraints.EAST, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 5, 5), 0, 0));
    UIDPanel.add(employeeNumberLabel, new GridBagConstraints(0, 0, 2, 1, 0.0, 0.0
            ,GridBagConstraints.EAST, GridBagConstraints.NONE, new Insets(0, 2, 0, 2), 0, 0));
    UIDPanel.add(givenNameLabel, new GridBagConstraints(0, 1, 1, 2, 0.0, 0.0
            ,GridBagConstraints.EAST, GridBagConstraints.VERTICAL, new Insets(0, 2, 0, 2), 23, 0));
    UIDPanel.add(uidTextField, new GridBagConstraints(2, 2, 1, 2, 1.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 5, 5), 0, 0));
    UIDPanel.add(uidLabel, new GridBagConstraints(0, 3, 1, 1, 0.0, 0.0
            ,GridBagConstraints.EAST, GridBagConstraints.VERTICAL, new Insets(0, 2, 0, 2), 0, 0));
    panel1.add(centerPanel, BorderLayout.CENTER);
    centerPanel.add(okButton, null);
    centerPanel.add(cancelButton, null);
    this.getContentPane().add(bottomPanel, BorderLayout.SOUTH);
    bottomPanel.add(statusLabel, BorderLayout.CENTER);
    employeeNumberTextField.setNextFocusableComponent(givenNameTextField);
    givenNameTextField.setNextFocusableComponent(uidTextField);
    uidTextField.setNextFocusableComponent(okButton);
    this.setSize(new Dimension(400, 188));
  }

  void cancelButton_actionPerformed(ActionEvent e) {
   okButtonPressed = false;
    this.hide();
  }

  void okButton_actionPerformed(ActionEvent e) {
    if (employeeNumberTextField.getText().equalsIgnoreCase("")) {
      okButtonPressed = false;
      statusLabel.setText("Status: MATRCULA no pode ser vazia!");
      employeeNumberTextField.requestFocus();
    }
    else if (givenNameTextField.getText().equalsIgnoreCase("")) {
      okButtonPressed = false;
      statusLabel.setText("Status: NOME no pode ser vazio!");
      givenNameTextField.requestFocus();
    }
    else if (uidTextField.getText().equalsIgnoreCase("")) {
      okButtonPressed = false;
      statusLabel.setText("Status: LOGIN no pode ser vazio!");
      uidTextField.requestFocus();
    }
    else {
      okButtonPressed = true;
      this.hide();
    }
  }


  void this_mouseMoved(MouseEvent e) {
    GlobalDefinitions.isUsed = true;
  }

  void this_windowOpened(WindowEvent e) {
    employeeNumberTextField.requestFocus();
  }

  void this_windowClosed(WindowEvent e) {
  }

  void textField_keyPressed(KeyEvent e) {
    if (e.getKeyCode() == KeyEvent.VK_ENTER) {
      e.getComponent().transferFocus();
    }
  }

  void givenName_keyPressed(KeyEvent e) {
    if (e.getKeyCode() == KeyEvent.VK_ENTER) {
      String nome = givenNameTextField.getText().trim();
      StringTokenizer strToken = new StringTokenizer(nome);
      givenNameTextField.setText(this.formatNamesToLowerCase(nome));
      strToken = new StringTokenizer(givenNameTextField.getText());
      if (strToken.countTokens() >= 2) {
        String uid = strToken.nextToken();
        String lastStr = "";
        while (strToken.hasMoreTokens()) {
          lastStr = strToken.nextToken();
        }
        uid = (uid + "." + lastStr).toLowerCase();
        uidTextField.setText(uid);
      }
      else {
        uidTextField.setText(givenNameTextField.getText());
      }
      e.getComponent().transferFocus();
    }
  }

  void employeeNumberTextField_keyPressed(KeyEvent e) {
    if (e.getKeyCode() == KeyEvent.VK_ENTER) {
      if (employeeNumberTextField.getText().equalsIgnoreCase("")) {
        okButtonPressed = false;
        statusLabel.setText("Status: Entre com um nmero de matrcula!");
        employeeNumberTextField.requestFocus();
      }
      else {
        e.getComponent().transferFocus();
      }
    }
  }

  void okButton_focusGained(FocusEvent e) {
    this.rootPane.setDefaultButton(okButton);
  }

  void okButton_focusLost(FocusEvent e) {
    this.rootPane.setDefaultButton(null);
  }


}