package maca_ad;

/**
 * <p>Title: MACA_CA</p>
 * <p>Description: Middleware de Autenticao e Controle de Acesso</p>
 * <p>Copyright: Copyright (c) 2000-2004</p>
 * <p>Company: Instituto do Corao - FM.USP</p>
 * @author Gustavo Motta
 * @version 3.2.1
 */

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import javax.swing.JFrame;

public class UserFrame extends JFrame {
  /**
   * @link aggregation
   */
  private UserApplet userApplet = null;

  public UserFrame() {
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }

  public void setUserApplet(UserApplet applet) {
    if (userApplet == null) {
      userApplet = applet;
      this.getContentPane().add(userApplet, BorderLayout.CENTER);
    }
  }

  private void jbInit() throws Exception {
    this.enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    this.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
    this.setSize(600,400);
    Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
    this.setLocation((d.width - this.getSize().width) / 2, (d.height - this.getSize().height) / 2);
    this.addWindowListener(new java.awt.event.WindowAdapter() {

      public void windowOpened(WindowEvent e) {
        this_windowOpened(e);
      }

      public void windowClosing(WindowEvent e) {
        this_windowClosing(e);
      }



    });
  }

  void this_windowOpened(WindowEvent e) {
    if (userApplet != null) {
      userApplet.givenNameTextField.requestFocus();
    }
  }

  void this_windowClosing(WindowEvent e) {
    if (userApplet != null) {
      userApplet.stop();
    }
  }

  protected void processWindowEvent(WindowEvent e) {
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      if (userApplet.closeWindow()) {
        super.processWindowEvent(e);
      }
    }
    else {
      super.processWindowEvent(e);
    }
  }



}