<?xml version='1.0' ?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
<xsl:include href="header_nojs.xsl"/>

<xsl:template match="document">
  <xsl:variable name="lookupname" select="/document/lookup/lookupname"/>
  <xsl:variable name="lookupupdatefield" select="/document/lookup/lookupupdatefield"/>
  <xsl:variable name="lookupdisplayfield" select="/document/lookup/lookupdisplayfield"/>
  <xsl:variable name="keyField" select="/document/keyField"/>
  <font face="Arial" size = "-1"><h3>Consulta de <xsl:value-of select="$lookupupdatefield"/></h3></font>
  <table border="0" width="100%" bgcolor="#FFFFFF">
    <form action="UserLookup.jsp" method="post">
    <tr>
      <td>
        <br/>
      </td>
    </tr>
    <tr>
      <td>
        <font face="Arial" size = "-1">Busca por
          <select name="lookupsearchfield" size="1">
            <option selected="true"><xsl:value-of select="$lookupdisplayfield"/></option>
            <option><xsl:value-of select="$lookupupdatefield"/></option>
          </select>:
          <input type="text" name="lookupfieldvalue" value="{$keyField}"/> <INPUT type="checkbox" name="exactmatch" value="false">Busca exata</INPUT>
        </font>
      </td>
    </tr>
    <tr>
      <td>
        <font face="Arial" size = "-1"><INPUT type="submit" name="lookupsearch" value="Pesquisar"/>&#xa0;&#xa0;<INPUT type="reset"/></font>
      </td>
    </tr>
    <tr>
      <td>
        <xsl:variable name="page" select="/document/page"/>
        <input type="hidden" name="page" value="{$page}"/>
      </td>
    </tr>
    <tr>
      <td>
        <xsl:variable name="lookupnumber" select="/document/lookupnumber"/>
        <input type="hidden" name="lookupnumber" value="{$lookupnumber}"/>
      </td>
    </tr>
    </form>
    <tr>
      <td>
        <xsl:if test="maca_ads">
          <xsl:apply-templates select="maca_ads"/>
        </xsl:if>
      </td>
    </tr>
  </table>
</xsl:template>


  <xsl:template match="maca_ads">
    <xsl:apply-templates select="response"/>
  </xsl:template>

  <xsl:template match="response">
    <xsl:variable name="min" select="/document/pages/min"/>
    <xsl:variable name="max" select="/document/pages/max"/>
    <xsl:variable name="lookupdisplayfield" select="/document/lookup/lookupdisplayfield"/>
    <xsl:variable name="status" select="@status"/>
    <xsl:variable name="page" select="/document/page"/>
    <xsl:variable name="lookupnumber" select="/document/lookupnumber"/>
    <xsl:variable name="lookupname" select="/document/lookup/lookupname"/>
    <xsl:variable name="lookupupdatefield" select="/document/lookup/lookupupdatefield"/>

    <xsl:choose>
    <xsl:when test="$status='ok'">
       <br clear="all"/>
       <hr/>
       <br clear="all"/>
          <TABLE Border = "0" Cellspacing = "0" Cellpadding = "2" Width = "100%" bgcolor="#FFFFFF">
          <xsl:choose>
          <xsl:when test="row">
            <tr>
              <td colspan="2">
                <font face="Arial" size = "-1"><b>A consulta retornou <xsl:value-of select="count(row)"/> resultado(s).</b></font>
              </td>
            </tr>
            <tr>
              <td>
                <br clear="all"/>
              </td>
            </tr>
            <xsl:for-each select="row">
              <xsl:sort select="attribute[@name=$lookupdisplayfield]/value"/>
              <xsl:variable name="value" select="./attribute[@name=$lookupupdatefield]/value"/>
              <!-- preciso de um tratamento especial para a primeira linha-->
              <xsl:choose>
                <xsl:when test="position()=1">
                  <!-- para a primeira linha eu pego os titulos-->
                  <tr class="clsEven">
                    <xsl:for-each select="attribute">
                      <xsl:variable name="name" select="@name"/>
                      <th><font face="Arial" size = "-1"><xsl:value-of select="@name"/></font></th>
                    </xsl:for-each>
                  </tr>
                  <tr bgcolor="white">
                    <xsl:for-each select="attribute">
                      <td>
                        <xsl:choose>
                        <xsl:when test="$page = 'SignUp'">
                          <xsl:variable name="displayname" select="../attribute[@name='NOME']/value"/>
                          <a href="javascript:remote3('{$lookupname}','{$lookupupdatefield}','{$value}','{$displayname}')"><font face="Arial" size = "-1"><xsl:value-of select="value"/></font></a>
                        </xsl:when>
                        <xsl:otherwise>
                           <a href="javascript:remote2('{$lookupname}','{$lookupupdatefield}','{$value}','{$page}','{$lookupnumber}')"><font face="Arial" size = "-1"><xsl:value-of select="value"/></font></a>
                        </xsl:otherwise>
                        </xsl:choose>
                      </td>
                    </xsl:for-each>
                  </tr>
                </xsl:when>
                <xsl:otherwise>
                  <tr>
                    <xsl:choose>
                    <xsl:when test="position() mod 2 = 1">
                      <xsl:attribute name="class">clsOdd</xsl:attribute>
                    </xsl:when>
                    <xsl:otherwise>
                      <xsl:attribute name="class">clsEven</xsl:attribute>
                    </xsl:otherwise>
                    </xsl:choose>
                    <xsl:for-each select="attribute">
                      <td>
                        <xsl:choose>
                        <xsl:when test="$page = 'SignUp'">
                          <xsl:variable name="displayname" select="../attribute[@name='NOME']/value"/>
                          <a href="javascript:remote3('{$lookupname}','{$lookupupdatefield}','{$value}','{$displayname}')"><font face="Arial" size = "-1"><xsl:value-of select="value"/></font></a>
                        </xsl:when>
                        <xsl:otherwise>
                          <a href="javascript:remote2('{$lookupname}','{$lookupupdatefield}','{$value}','{$page}','{$lookupnumber}')"><font face="Arial" size = "-1"><xsl:value-of select="value"/></font></a>
                        </xsl:otherwise>
                        </xsl:choose>
                      </td>
                    </xsl:for-each>
                  </tr>
                </xsl:otherwise>
              </xsl:choose>
            </xsl:for-each>
          </xsl:when>
          <xsl:otherwise>
            <tr>
              <td>
                <font face="Arial" size = "-1"><b>A pesquisa não retornou nenhum resultado.</b></font>
              </td>
            </tr>
          </xsl:otherwise>
          </xsl:choose>
          </TABLE>
      <br/>
    </xsl:when>
    <xsl:otherwise>
       <xsl:variable name="errormessage" select="response[@errormessage]"/>
       <br clear="all"/>
       <br clear="all"/>
       <hr/>
       <br clear="all"/>
       <font face="Arial" size = "-1"><b>Erro:</b> <xsl:value-of select="$errormessage"/></font>
    </xsl:otherwise>
    </xsl:choose>

  </xsl:template>

</xsl:stylesheet>


