package maca_cs;

/**
 * <p>Title: MACA_CA</p>
 * <p>Description: Middleware de Autenticao e Controle de Acesso</p>
 * <p>Copyright: Copyright (c) 2000-2004</p>
 * <p>Company: Instituto do Corao - FM.USP</p>
 * @author Gustavo Motta
 * @version 3.2.1
 */

import maca_ca.*;
import java.util.*;
import javax.naming.*;
import javax.naming.directory.*;

public class UserContext implements  contexts.Context {
  private User _user = null;

  private boolean contains(Attribute attr, Object element) throws NamingException {
    if (attr != null) {
      Enumeration enum = attr.getAll();
      while (enum.hasMoreElements()) {
        Object attrValue = enum.nextElement();
        if (attrValue != null) {
          if ((attrValue instanceof String) &&
              (element instanceof String))  {
            if (((String)attrValue).equalsIgnoreCase((String)element)) {
              return true;
            }
          }
          else if (attrValue.equals(element)) {
            return true;
          }
        }
        else if (attrValue == element) {
          return true;
        }
      }
    }
    return false;
  }

  public UserContext(User aUser) {
    this._user = aUser;
  }


  public Object getValue(String index) throws contexts.ContextException {
    if (this._user != null) {
      if (index.equalsIgnoreCase("login")) {
        return this._user.getUserID();
      }
      else if (index.equalsIgnoreCase("matricula")) { try {
        Attribute attr = this._user.getUserAtributes().get("employeenumber");
        if ((attr != null) && (attr.get() != null)) {
          return attr.get();
        }
        else {
          return "";
        }
        }
        catch (javax.naming.NamingException exc) {
          throw new contexts.ContextException("Erro avaliando varivel '"+index+" no contexto 'UserContext': "+exc.toString(true));
        }
      }
      else if (index.equalsIgnoreCase("area_meio")) { try {
        Attribute attr = this._user.getUserAtributes().get("employeetype");
        if ((attr != null) && (attr.get() != null)) {
          return attr.get();
        }
        else {
          return "";
        }
        }
        catch (javax.naming.NamingException exc) {
          throw new contexts.ContextException("Erro avaliando varivel '"+index+"' no contexto 'UserContext': "+exc.toString(true));
        }
      }
      else { try {
        Attribute attr = this._user.getUserAtributes().get(index);
        if ((attr != null) && (attr.get() != null)) {
          return attr.get();
        }
        else {
          return "";
        }
        }
        catch (javax.naming.NamingException exc) {
          throw new contexts.ContextException("Erro avaliando varivel '"+index+"' no contexto 'UserContext': "+exc.toString(true));
       }
      }
    }
    else {
      throw new contexts.ContextException("Varivel '"+index+"' indisponvel no contexto 'UserContext'.");
    }
  }

  public boolean inEvaluation(Object element, Object aSet) throws contexts.ContextException {
    if (aSet instanceof String) {
      if (this._user != null) {
        if ("papeis_associados".equalsIgnoreCase((String)aSet)) { try {
          return (element instanceof String)?this._user.hasRole((String) element):false;
          }
          catch (javax.naming.NamingException exc) {
            throw new contexts.ContextException("Erro avaliando conjunto '"+aSet+"' no contexto 'UserContext': "+exc.toString(true));
          }
        }
        else { try {
          Attribute attr = this._user.getUserAtributes().get((String)aSet);
          if ((attr != null) && (element != null)) {
            if ((element instanceof String) && (!"".equals(element))) {
              return contains(attr, element);
            }
            else if ((element instanceof Attribute) && ((Attribute) element).size() > 0) {
              Attribute elemAttr = (Attribute) element;
              Enumeration enum = elemAttr.getAll();
              while (enum.hasMoreElements()) {
                if (!contains(attr, enum.nextElement())) {
                  return false;
                }
              }
              return true;
            }
            return false;
          }
          else {
             return false;
          }
          }
          catch (Exception exc) {
            throw new contexts.ContextException("Erro avaliando conjunto '"+aSet+"' no contexto 'UserContext': "+exc.toString());
          }
        }
      }
      else {
        throw new contexts.ContextException("Conjunto '"+aSet+"' indisponvel no contexto 'UserContext'.");
      }
    }
    else {
      throw new contexts.ContextException("Conjunto '"+aSet+"' indisponvel no contexto 'UserContext'.");
    }
  }

  public Object functionApplication(String parm1, Vector parm2) throws contexts.ContextException {
    /**@todo: Implement this contexts.Context method*/
    throw new java.lang.UnsupportedOperationException("Method functionApplication() not yet implemented no contexto 'UserContext'.");
  }
}