<?xml version='1.0'?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
<xsl:include href="header.xsl"/>

<!--
<xsl:output method="html"/>
<xsl:variable name="uid2"/>

<xsl:template match="/">
<html>
<STYLE>
TR.clsOdd { background-Color:  #ffffff; }
TR.clsEven { background-color: #eeeeee; }
</STYLE>
<head>
     <title>Lista de Usuários</title>
</head>
<body>
<font face="Arial" size = "-1">
<xsl:apply-templates  select="/maca_cs"/>
</font>
</body>
</html>
</xsl:template>
-->
<xsl:template match="document">
<font face="Arial" size = "-1"><h3>Usuários -> Listar todos os Usuários</h3></font>
<table border="0" width="100%" bgcolor="#EDEDED">
<tr>
<xsl:apply-templates select="maca_cs"/>
</tr>
<tr>
<xsl:apply-templates select="pages"/>
</tr>
</table>
</xsl:template>

  <xsl:template match="maca_cs">
      <br/>
      <br/>
          <TABLE Border = "0" Cellspacing = "0" Cellpadding = "2" Width = "100%" bgcolor="#EDEDED">
            <tr>
              <th><font face="Arial" size = "-1">Nome</font></th>
              <th><font face="Arial" size = "-1">E-mail</font></th>
              <th><font face="Arial" size = "-1">Papéis Ativos</font></th>
              <th><font face="Arial" size = "-1">Papéis Disponíveis</font></th>
              <th><font face="Arial" size = "-1">Operações</font></th>
              <th><font face="Arial" size = "-1">ID e Data/Hora de início da sessão</font></th>
            </tr>
            <xsl:apply-templates select="response"/>
         </TABLE>
      <br/>
      <br/>

  </xsl:template>

  <xsl:template match="response">
    <xsl:variable name="min" select="/document/pages/min"/>
    <xsl:variable name="max" select="/document/pages/max"/>
    <!--
    Min response: <xsl:value-of select="$min"/>
    Max response: <xsl:value-of select="$max"/>
    -->

      <xsl:for-each select="user">
          <xsl:sort select="ldapentry/attribute[@name='uid']/value"/>
          <xsl:if test = "position() &gt;= $min and position() &lt;= $max">
          <tr>
          <!--Posição:<xsl:value-of select="position()"/>-->
          <xsl:choose>
             <xsl:when test="position() mod 2 = 1">
                <xsl:attribute name="class">clsOdd</xsl:attribute>
             </xsl:when>
             <xsl:otherwise>
                <xsl:attribute name="class">clsEven</xsl:attribute>
             </xsl:otherwise>
          </xsl:choose>
             <xsl:apply-templates select="ldapentry"/>
             <xsl:choose>
               <xsl:when test="roles[@type='active']">

                  <xsl:apply-templates select="roles[@type='active']"/>
               </xsl:when>
               <xsl:otherwise>
                  <td>
                    <font face="Arial" size = "-1">(não possui papéis ativos)</font>
                  </td>
               </xsl:otherwise>
             </xsl:choose>
             <xsl:choose>
               <xsl:when test="roles[@type='available']">
                  <xsl:apply-templates select="roles[@type='available']"/>
               </xsl:when>
               <xsl:otherwise>
                  <td>
                    <font face="Arial" size = "-1">(não possui papéis disponíveis)</font>
                  </td>
               </xsl:otherwise>
             </xsl:choose>
             <td>
                <xsl:variable name="uid" select="ldapentry/attribute[@name='uid']/value"/>
                <font face="Arial" size = "-1"><a href="ResetCache.jsp?uid={$uid}&amp;page=list">Limpar Cache</a></font>
             </td>
             <xsl:apply-templates select="sessions"/>
           </tr>
          </xsl:if>
      </xsl:for-each>
  </xsl:template>

  <xsl:template match="ldapentry">
      <xsl:choose>
         <xsl:when test="attribute[@name='uid']">
             <xsl:apply-templates select="attribute[@name='uid']"/>
         </xsl:when>
         <xsl:otherwise>
              <td>
                 <font face="Arial" size = "-1">(não possui nome)</font>
              </td>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:choose>
         <xsl:when test="attribute[@name='mail']">
              <xsl:apply-templates select="attribute[@name='mail']"/>
         </xsl:when>
         <xsl:otherwise>
              <td>
                 <font face="Arial" size = "-1">(não possui e-mail)</font>
              </td>
         </xsl:otherwise>
      </xsl:choose>
  </xsl:template>

  <xsl:template match="attribute[@name='uid']">
        <td>
            <font face="Arial" size = "-1"><b><xsl:value-of select="value"/></b></font>
        </td>
  </xsl:template>

  <xsl:template match="attribute[@name='mail']">
        <td>
           <xsl:choose>
             <xsl:when test="value">
               <font face="Arial" size = "-1"><i><xsl:value-of select="value"/></i></font>
             </xsl:when>
             <xsl:otherwise>
               <font face="Arial" size = "-1">(não possui e-mail)</font>
             </xsl:otherwise>
           </xsl:choose>
        </td>
  </xsl:template>

  <xsl:template match="roles[@type='active']">
        <td>
            <xsl:apply-templates select="./ldapentry/attribute[@name='cn']"/>
        </td>
  </xsl:template>

  <xsl:template match="roles[@type='available']">
        <td>
            <xsl:apply-templates select="ldapentry/attribute[@name='cn']"/>
        </td>
  </xsl:template>

  <xsl:template match="ldapentry/attribute[@name='cn']">
       <xsl:choose>
          <xsl:when test="value">
             <xsl:for-each select="value">
                 <font face="Arial" size = "-1"><xsl:value-of select="."/>; </font>
             </xsl:for-each>
          </xsl:when>
          <xsl:otherwise>
              <font face="Arial" size = "-1">(nenhum)</font>
          </xsl:otherwise>
        </xsl:choose>
  </xsl:template>

  <xsl:template match="sessions">
      <td>
      <xsl:choose>
      <xsl:when test="count(./session) &gt; 1">
        <ul>
          <li id="foldheader">Sessoes abertas do Usuario</li>
          <ul id="foldinglist" style="display:none;&amp;{head};">
         <!--<div class="look"><img src="fold.gif" class="folding"/><a>Sessoes abertas do Usuario</a>-->
         <!--   <ul class="look2" style="list-style-image:url(list.gif);display:none">-->
                <xsl:for-each select="session">
                  <xsl:variable name="uid" select="./../../ldapentry/attribute[@name='uid']/value"/>
                  <xsl:variable name="number" select="@number"/>
                  <li>
                  <xsl:choose>
                    <xsl:when test="@number">
                      <font face="Arial" size = "-1"><xsl:value-of select="@number"/></font>
                    </xsl:when>
                    <xsl:otherwise>
                      <font face="Arial" size = "-1">(nenhuma)</font>
                    </xsl:otherwise>
                  </xsl:choose>
                  <xsl:choose>
                    <xsl:when test="@creationtimestamp">
                      <font face="Arial" size = "-1"><xsl:value-of select="@creationtimestamp"/></font>
                    </xsl:when>
                    <xsl:otherwise>
                      <font face="Arial" size = "-1">(nenhum)</font>
                    </xsl:otherwise>
                  </xsl:choose>
                  <font face="Arial" size = "-1">;<a href="KillSession.jsp?uid={$uid}&amp;sessionnumber={$number}&amp;page=list">Encerrar Sessao</a></font>
                  </li>
               </xsl:for-each>
             </ul>
           <!--</div>-->
           </ul>
         </xsl:when>
         <xsl:otherwise>
                <xsl:for-each select="session">
                  <xsl:variable name="uid" select="./../../ldapentry/attribute[@name='uid']/value"/>
                  <xsl:variable name="number" select="@number"/>
                  <xsl:choose>
                    <xsl:when test="@number">
                      <font face="Arial" size = "-1"><xsl:value-of select="@number"/></font>;
                    </xsl:when>
                    <xsl:otherwise>
                      <font face="Arial" size = "-1">(nenhuma)</font>
                    </xsl:otherwise>
                  </xsl:choose>
                  <xsl:choose>
                    <xsl:when test="@creationtimestamp">
                      <font face="Arial" size = "-1"><xsl:value-of select="@creationtimestamp"/></font>;
                    </xsl:when>
                    <xsl:otherwise>
                      <font face="Arial" size = "-1">(nenhum)</font>
                    </xsl:otherwise>
                  </xsl:choose>
                  <font face="Arial" size = "-1"><a href="KillSession.jsp?uid={$uid}&amp;sessionnumber={$number}&amp;page=list">Encerrar Sessao</a></font>
               </xsl:for-each>
         </xsl:otherwise>
      </xsl:choose>
      </td>
  </xsl:template>


    <xsl:template match="pages">
 <!--
<xsl:variable name="numrows" select="20"/>
<xsl:variable name="numusers" select="count(./maca_cs/response/user)"/>
<xsl:variable name="aux" select="$numusers div $numrows"/>
<xsl:choose>
  <xsl:when test="$aux>0">
    <xsl:choose>
    <xsl:when test="$numusers mod $numrows = 0">
      <xsl:variable name="numpages" select="$aux"/>
    </xsl:when>
    <xsl:otherwise>
      <xsl:variable name="numpages" select="$aux+1"/>
    </xsl:otherwise>
    </xsl:choose>
  </xsl:when>
  <xsl:otherwise>
  <xsl:variable name="numpages" select="1"/>
  </xsl:otherwise>
</xsl:choose>
 -->
 <TABLE bgcolor="#EDEDED" Width="100%" Cellpadding="0" Cellspacing="0" Border="0">
    <xsl:variable name="min" select="min"/>
    <xsl:variable name="max" select="max"/>
    <xsl:variable name="numberusers" select="numberusers"/>
 <tr>
    <td align="left" Width="25%">
    <xsl:if test="./previouspage">
      <xsl:apply-templates select="previouspage"/>
    </xsl:if>
    </td>
    <td align="center" Width="50%">
    <font face="Arial" size = "-1">Mostrando usuários: <xsl:value-of select="min"/> a <xsl:value-of select="max"/> de <xsl:value-of select="numberusers"/></font>
    </td>
    <td align="right" Width="25%">
    <xsl:if test="./nextpage">
      <xsl:apply-templates select="nextpage"/>
    </xsl:if>
    </td>
 </tr>
 </TABLE>
  </xsl:template>

    <xsl:template match="previouspage">
      <xsl:variable name="pagemin" select="pagemin"/>
      <xsl:variable name="pagemax" select="pagemax"/>
      <font face="Arial" size = "-1"><a href="MonitorList.jsp?min={$pagemin}&amp;max={$pagemax}">&lt;&lt; Página Anterior</a></font>
    </xsl:template>
    <xsl:template match="nextpage">
      <xsl:variable name="pagemin" select="pagemin"/>
      <xsl:variable name="pagemax" select="pagemax"/>
       <font face="Arial" size = "-1"><a href="MonitorList.jsp?min={$pagemin}&amp;max={$pagemax}">Página Seguinte &gt;&gt;</a></font>
    </xsl:template>
</xsl:stylesheet>

<!--
Exemplo de xml a ser processado:

<maca_cs version="3.1">
<response action="ListarAtivos;Usuarios;Monitor;MACA" status="ok" message="1 usuários simultâneos.">
        <user>
                <ldapentry dn="uid=luiz.kobayashi,ou=people,dc=incor,dc=usp,dc=br">
                        <attribute name="uid">
                                <value><![CDATA[luiz.kobayashi]]></value>
                        </attribute>
                        <attribute name="mail">
                                <value><![CDATA[luiz.kobayashi@incor.usp.br]]></value>
                        </attribute>
                </ldapentry>
                <roles type="active">
                        <ldapentry dn="cn=Administrador,cn=papeis,ou=groups,dc=incor,dc=usp,dc=br">
                                <attribute name="cn">
                                        <value><![CDATA[Administrador]]></value>
                                </attribute>
                        </ldapentry>
                </roles>
                <roles type="available">
                </roles>
                <sessions>
                        <session number="0003" creationtimestamp="31/01/2003 12:25:46.637 BRST">
                        </session>
                        <session number="0002" creationtimestamp="31/01/2003 12:24:31.438 BRST">
                        </session>
                </sessions>
        </user>
</response>
</maca_cs>
-->
